#include <windows.h>
#include <assert.h>
#include "BCKeyMan.h"
#include "..\Includes\UnicodeFuncs.h"
#include "..\Includes\TranslateDll.h"
#include "..\Includes\cDlg.h"

HINSTANCE hMainInst = 0;

cTranslateDll translateDll;
cInstanceHolder IH;

bool UpdateModuleTranslation()
{
	//
	//	Note, Windows Vista ( may be others systems too ) caches name of once loaded help file by HtmlHelp.
	//	So it does not change help file path on fly :(
	//	No reset helps.
	//

	translateDll.m_wcsLangFilePath.Free();

	// BestCrypt or BCArchive
	wchar_t mainModule[ MAX_PATH ];
	GetModuleFileNameT( NULL, mainModule, maxLen( mainModule ) );

	const wchar_t *localModuleName = mainModule + splitPath( mainModule );

	wchar_t path[ MAX_PATH ];
	GetModuleFileNameT( hMainInst, path, maxLen( path ) );
	
	const wchar_t *utilName = path + splitPath( path, path );

	translateDll.SetDefault( path, localModuleName, utilName );

	return true;
}


BOOL APIENTRY DllMain(
			HANDLE hModule, 
			DWORD  ul_reason_for_call, 
			LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		{
			hMainInst = (HINSTANCE)hModule;
			IH.SetHolder( hMainInst );
			UpdateModuleTranslation();
			GetPGPServicesList( hMainInst );

			break;
		}
		case DLL_PROCESS_DETACH:
			translateDll.Unload();
			FreePGPServicesList();
			break;

		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
			break;
    }
    return TRUE;
}

