#include "DlgAbout.h"
#include <assert.h>
#include "..\Includes\getFileVersion.h"
#include "..\Includes\TranslateDll.h"
#include <stdio.h>

LRESULT cDlgAbout::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
		case WM_INITDIALOG: InitDialog(); break;
		case WM_COMMAND: 	OnCommand( wParam, lParam ); break;
		case WM_MOUSEMOVE:
		{
			UINT nFlags = wParam;
			POINT point = { LOWORD( lParam ), HIWORD( lParam ) };

			bool cc = true;
			cc &= Clipped( GetDlgItem( m_hDlg, IDC_EmailString ), point );
			cc &= Clipped( GetDlgItem( m_hDlg, IDC_HitString ), point );
			cc &= Clipped( GetDlgItem( m_hDlg, IDC_TranslatorEmail ), point );
			cc &= Clipped( GetDlgItem( m_hDlg, IDC_TranslatorHTTPPage ), point );
		
			if ( cc )
			{
				SetCursor( m_hcFinger );
			}
			else
			{
//				assert( !Clipped( GetDlgItem( m_hDlg, IDC_EmailString ), point ) );
				SetCursor(m_hcArrow);
			}

			return FALSE;
		}
		case WM_LBUTTONUP:
		{
			POINT point = { LOWORD( lParam ), HIWORD( lParam ) };
			OnLButtonUp( GetDlgItem( m_hDlg, IDC_HitString ), point );
			OnLButtonUp( GetDlgItem( m_hDlg, IDC_EmailString ), point );
			OnLButtonUp( GetDlgItem( m_hDlg, IDC_TranslatorEmail ), point );
			OnLButtonUp( GetDlgItem( m_hDlg, IDC_TranslatorHTTPPage ), point );
			break;
		}
		case WM_CTLCOLORSTATIC:
		{
			ULONG res = (ULONG)CtlColor( (HDC)wParam, (HWND)lParam );
			SetWindowLong(m_hDlg, DWL_MSGRESULT, res );
			return res;
		}
		case WM_SETTINGCHANGE:
		{
			const char *szUnInstall	= "UnInstall";
			char *section = (char *)lParam;

			if (!strcmp( section, szUnInstall)) // Send by UnInstall...
				PostQuitMessage(0);

			break;
		}
		default:
			return FALSE;
	}

	return TRUE;
}

ULONG cDlgAbout::Notify(NMHDR *pnmh)
{
	return 0;
}

HBRUSH cDlgAbout::CtlColor( HDC hDC, HWND hWnd )
{
	int id = GetDlgCtrlID( hWnd );

	switch ( id )
	{
		case IDC_HitString:
		case IDC_EmailString:
		case IDC_TranslatorEmail:
		case IDC_TranslatorHTTPPage:
			break;
		default : return NULL;
	}

	SetBkMode( hDC, TRANSPARENT );
	SetTextColor( hDC, m_clrText );   // text Color 
	return m_brBkgnd;				// ctl bkgnd
}

void cDlgAbout::OnLButtonUp( HWND hWnd, POINT point )
{
	RECT r;
	GetWindowRect( hWnd, &r );
	ClientToScreen( m_hDlg, &point );

	if ( !PtInRect( &r, point ))
		return;

	wchar_t s[100];
	GetWindowTextT( hWnd, s, maxLen( s ) );
	ShellExecuteT(
		hWnd,  // handle to parent window
		L"open",             // pointer to string that specifies operation to perform
		s,					 // pointer to filename or folder name string  
		NULL,	             // pointer to string that specifies executable-file parameters
		NULL,	             // pointer to string that specifies default directory
		0                    // whether file is shown when opened
	);
}

void cDlgAbout::InitDialog()
{
	//	SetRCValues( IDC_Line, IDC_STATIC_BOLD, IDC_Text, IDI_Main );

	UpdateTranslatorInfo( m_hDlg, IDC_TranslatorInfo, IDC_TranslatorName, IDC_TranslatorEmail, IDC_TranslatorHTTPPage );

	wchar_t name[ MAX_PATH ];
	GetModuleFileNameT( m_hInst, name, maxLen( name ) );

	wchar_t version[ 100 ];
	DWORD size = maxLen( version );
	if ( getFileVersionT( name, version, &size, L"LegalCopyright" ) )
		SetDlgItemTextT( IDC_copyrightStr, version );
	
	size = maxLen( version );
	getFileVersionT( name, version, &size );

	wchar_t pattern[ 256 ];

	GetDlgItemTextT( IDC_Text, pattern, maxLen( pattern ) );

	wchar_t text[ 256 ];
	::FormatT( text, maxLen( text ), pattern, version );

	SetDlgItemTextT( IDC_Text, text );


//	m_hcFinger = LoadCursor( m_hInst, MAKEINTRESOURCE(IDC_Finger) );
	m_hcArrow = LoadCursor( NULL, IDC_ARROW );

#ifndef IDC_HAND
#define IDC_HAND MAKEINTRESOURCE(32649)
#endif

	m_hcFinger = LoadCursor( NULL, IDC_HAND );
	if ( m_hcFinger == NULL )
		m_hcFinger = LoadCursor( NULL, IDC_CROSS );

	m_clrText = RGB( 0, 0, 255 );
	COLORREF clrBkgnd = GetSysColor( COLOR_BTNFACE );
	m_brBkgnd = CreateSolidBrush( clrBkgnd );
}

int cDlgAbout::OnCommand( WPARAM wParam, LPARAM lParam )
{
	switch( wParam )
	{
		case IDCANCEL:
		case IDOK:
			EndDialog( m_hDlg, IDOK );
			return 0;
		default: break;
	}

	return 0;
}
