#ifndef __PKParse__
#define __PKParse__

#include <windows.h>
#include "..\CertificateLib\SMemory\SBlocks.h"
#ifndef HPKA
typedef class cPKA * HPKA;
#endif

#define DllExport __declspec( dllexport )

extern "C"
{
//
//	Function: DecodePGPPublicKeyBlock
//		Finds armored body.
//		Extract armored headers
//		Decodes the extracted body.
//
DllExport int DecodePGPPublicKeyBlock(
	BYTE *msg,
	int msgSize,
	cPlainTextBlock *ptbKey,
	int *pParsed = NULL,
	const char **pHeaders = NULL );

//
//	ExtractDataAndVerifyPGPPublicKeyBlock
//		1. Parses key packet ( the packet has to be already decoded )
//		2. Verifies the key. It searches issuer key ring for the public key if the 
//			key is not self signed.
//		3. Generates specified values.
//
DllExport int ExtractDataAndVerifyPGPPublicKeyBlock(
		BYTE *pkt,	int pktSize,		// Public Key Packet with header.
		BYTE *issuerKR, int issuerKRSize,	// Key Ring where issuer can be found

		HPKA *pPka = NULL,	// Pointer to Key handle, if it is not NULL the key will be generated 
							// and has to be freed later.

		// It is set as pointer to position of user ID string in the pkt and it's size.
		BYTE **pUserID = NULL,	int *pUserIDSize = NULL,

		//
		// Both keys ID are 8 bytes size buffers, 
		//	if not NULLs the buffers are filled by subject/issuer generated key ID.
		//
		BYTE *keyID = NULL,		
		BYTE *issuerKeyID = NULL, 

		bool extractOnly = false, // Do not verify

		BYTE *pAlgID = NULL // Public key algorithm identifier f.e. pgppkaRSA defined in pktdef.h
	);
}

struct sPublicKey;

int IsEncryptionKey( sPublicKey *pk, int pkSize );

int DecodePGPKeyBlock( BYTE *msg, int msgSize, cPlainTextBlock *ptbKey, int *pParsed, const char **pHeaders, bool secret );

#endif // __PKParse__