#ifndef __ALG_DEF__
#define __ALG_DEF__


#ifndef VOID
typedef void VOID;
#endif

#ifndef NULL
#ifdef __cplusplus
#define NULL    0
#else
#define NULL    ((void *)0)
#endif
#endif

#ifndef __WinDefs__

#ifndef BYTE
typedef unsigned char BYTE;
#endif

#ifndef UCHAR
typedef unsigned char UCHAR;
#endif

#ifndef PUCHAR
typedef unsigned char *PUCHAR;
#endif

#ifndef WORD
typedef unsigned short WORD;
#endif

#ifndef USHORT
typedef unsigned short USHORT;
#endif

#ifndef _WINDEF_
#ifndef DWORD
#ifdef _WIN32
typedef unsigned long DWORD;
#else
typedef unsigned int DWORD;
#endif
#endif

#ifndef PDWORD
typedef DWORD *PDWORD;
#endif
#endif

#ifndef UINT
typedef unsigned int UINT;
#endif

#ifndef PUINT
typedef unsigned int *PUINT;
#endif

#ifndef BOOL
#ifndef __APPLE__
typedef int BOOL;
#else
typedef signed char BOOL;
#endif
#endif

#endif


#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE  1
#endif

#ifndef MAKEWORD
#define MAKEWORD(a, b)      ((WORD)(((BYTE)(((DWORD_PTR)(a)) & 0xff)) | ((WORD)((BYTE)(((DWORD_PTR)(b)) & 0xff))) << 8))
#endif

/*  Macroses to transform array of 4 bytes to 32-bit words
 *  (and reverse) without depending on the Little-Endian or 
 *  Big-Endian processor's architecture 
 */

#define BYTES_TO_UINT(b,d) (d =((UINT)(*((b)++))), \
                             d|=((UINT)(*((b)++)))<< 8, \
                             d|=((UINT)(*((b)++)))<<16, \
                             d|=((UINT)(*((b)++)))<<24)

#define UINT_TO_4BYTES(d,b) (*((b)++)=(BYTE)(((d)    )&0xff), \
                              *((b)++)=(BYTE)(((d)>> 8)&0xff), \
                              *((b)++)=(BYTE)(((d)>>16)&0xff), \
                              *((b)++)=(BYTE)(((d)>>24)&0xff))

/**********************************************************************
 *
 * Useful definitions
 *
 **********************************************************************/

#ifdef __INTEL_PLATFORM
  #define ROL(X, n) _asm rol X, n
#else
  #define ROL( X, n )	( ( ( X ) << n ) | ( ( X ) >> ( 32 - n ) ) )
#endif

#endif //__ALG_DEF__
