/*---------------------------------------------------------------------------*\

      Copyright (c) 2018 Jetico, Inc., Finland
      All rights reserved.

      File: sessionKey.h
      Revision:
      Created:
      Description:

\*---------------------------------------------------------------------------*/

#pragma once

#include "../symmetricAlgs/symmetricAlgs.h"
#include "../SMemory/cPassword.h"

class cSessionKey
{
public:
	HSA hsa;

	cPassword pwd;

	cSessionKey( const char *utf8pwd = NULL )
	{
		hsa = NULL;
		if ( utf8pwd != NULL )
			pwd.Set( utf8pwd );
	}
	
	int createAlgorithm( int algID, BYTE *keyBuff, int keyBuffSize )
	{
		closeKey();

		return sa_createAlgorithm( &hsa, algID, keyBuff, keyBuffSize );
	}

	void closeKey()
	{
		if ( hsa != NULL )
			sa_free( hsa );

		hsa = NULL;
	}

	~cSessionKey()
	{
		closeKey();
	}
};

