#pragma once

#include "CDll.h"
#include <objbase.h>

extern "C"
{
	typedef HRESULT __stdcall typeRegisterProc();
	typedef HRESULT __stdcall typeCoInitialize( LPVOID pvReserved ); //Reserved; must be NULL
	typedef void __stdcall typeCoUninitialize();
}	

class COleDll : public CDll
{
	HRESULT oleRes;
	CDll theOle;

public:

	bool Init()
	{
		error = true;
		hInst = NULL;
		
		oleRes = S_FALSE;

		theOle.Load( false, "ole32.dll", "CoInitialize" );

		if ( theOle.error )
			return false;
		
		typeCoInitialize *procCoInitialize = (typeCoInitialize *)theOle.pProc;
		oleRes = procCoInitialize( NULL );

		return oleRes == S_OK;
	}

	COleDll()
	{
		Init();
	}

	COleDll ( BOOL usePath , const char *libraryName, const char *procName = NULL, BOOL showMessage = TRUE )
	{
		Init();

		Load( usePath , libraryName, procName, showMessage );
	}

	COleDll ( BOOL usePath , const wchar_t *libraryName, const char *procName = NULL, BOOL showMessage = TRUE )
	{
		Init();

		Load( usePath , libraryName, procName, showMessage );
	}

	~COleDll()
	{
		if ( oleRes == S_OK )
		{
			if ( theOle.GetProcAddress( "CoUninitialize" ) )
			{
				typeCoUninitialize *procCoUninitialize = (typeCoUninitialize *)theOle.pProc;
				procCoUninitialize();
			}
		}
	}
};
