/*
 *	Copyright 1994-2013 Jetico, Inc. All rights reserved.
 *	EquStrings.h
 *	Functions for string comparation.
 *	Created:	11.05.1994 ( original name strsrv.h )
 *	Author:		Alexander Pichuev.
 */
#pragma once

#include <wchar.h>

//
//  EquStrings
//  Function for string comparation
//		with 
//		* - all any symbols,
//		% - one any symbols.
//	Only second string can content the symbols.
//
//	Example: following strings are equal
//      s1 - word    Example : "qwerty",
//      s2 - pattern Example : "q%e*y*".
//
bool EquStrings( const char *s, const char *pattern );
bool EquStrings( const char *s, const char *pattern, bool matchCase );
bool EquStrings( const wchar_t *s, const wchar_t *pattern );
bool EquStrings( const wchar_t *s, const wchar_t *pattern, bool matchCase );

//
//	EquList
//		Checks if string covered by the patternList.
//		Note, pattern list is zero separated and double zero terminated list of patterns.
//
bool EquList( const wchar_t *string, const wchar_t *mszPatternList, bool matchCase = true );

//
//	IsIncluded
//		Checks if string covered by the mszPatternListInclude but is not covered by mszPatternListExclude.
//		Note, the pattern lists are zero separated and double zero terminated list of patterns.
//
bool IsIncluded( const wchar_t *string, const wchar_t *mszPatternListInclude, const wchar_t *mszPatternListExclude, bool matchCase = true );

bool HasStarSymbols( const wchar_t *str );
bool RemoveStarSymbols( wchar_t *str, const wchar_t *startSymbols = NULL );
