#ifdef _UseFileViewA_

#include "FileViewA.h"
#include <io.h>
#include "ODS.H"

cFileViewA::cFileViewA()
{
	memset( this, 0, sizeof( *this ) );
}

BOOL cFileViewA::OpenMapping( bool readOnly )
{
	if ( m_hFile == INVALID_HANDLE_VALUE )
	{
		ODS_fl;
		return FALSE;
	}

	m_size = GetFileSize( m_hFile, NULL );

	if ( m_size == (DWORD)-1 )
	{
		ODS_fl;
		return FALSE;
	}

	if ( m_size == 0 )
	{
		m_err = cfv_ok;
		ODS_fl;
		return TRUE;
	}

	m_hMap = CreateFileMapping( m_hFile, NULL, ( readOnly ? PAGE_READONLY : PAGE_READWRITE ), 0, m_size, NULL ); // fileName );

	if ( m_hMap == NULL )
	{
		int err = GetLastError();
		ODSF( L"Error %d in CreateFileMapping", err );
		return FALSE;
	}

	m_ptr = (BYTE *)MapViewOfFile( m_hMap, ( readOnly ? FILE_MAP_READ : FILE_MAP_ALL_ACCESS ), 0, 0, m_size );

	if ( m_ptr == NULL )
	{
		int err = GetLastError();
		ODSF( L"Error %d in MapViewOfFile", err );
		return FALSE;
	}

	m_err = cfv_ok;
	return TRUE;
}

BOOL cFileViewA::Open( const char *fileName, bool readOnly )
{
	Close( ); //	memset( this, 0, sizeof( *this ) );
	m_err = cfv_fileDoesNotExist;

	if ( ( _access( fileName, 0 ) != 0 ) && readOnly )
		return FALSE;

	m_err = cfv_errorInOpeningFile;

	m_hFile =
		CreateFileA(
			fileName,
			( readOnly ? GENERIC_READ : GENERIC_READ | GENERIC_WRITE ),
			FILE_SHARE_READ | FILE_SHARE_WRITE,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			NULL);

	return OpenMapping( readOnly );
}

void cFileViewA::CloseMapping()
{
	if ( m_ptr )	{ UnmapViewOfFile( m_ptr );	m_ptr  = NULL; }
	if ( m_hMap )	{ CloseHandle( m_hMap );	m_hMap = NULL; }
}

void cFileViewA::Close( )
{
	if( m_hFile == NULL )
		return;

	CloseMapping();

	if ( m_hFile )	CloseHandle( m_hFile );

	memset( this, 0, sizeof( *this ) );
}
#endif // _UseFileViewA_