/*
 * Copyright 2000-2013 Jetico Inc. All rights reserved.
 *	FormatT.h
 *	Created:	2007 ( moved from UnicodeFuncs.h )
 *	Author:		Alexander Pichuev.
 *	Description:
 *		Prints formatted output to the buffer as wprintf does.
 *		Additional posibilites:
 *			Supports CString numeric format parameters like '%1 %2'
 *			Allows %P parameter, it adds specified number of probels to output string.
 */

#pragma once

#include <windows.h>
#include <stdio.h>

class cVAList
{
public:
	va_list marker;

	cVAList()
	{
	}

	~cVAList()
	{
		va_end( marker );
	}
};

//
//	Sample of using 
//
//	cVAList vl;
//	va_start( vl.marker, pattern );
//	FormatT( wcs.m_szBody, wcs.m_len, &vl, pattern );
//
extern wchar_t *FormatT( wchar_t *buff, int buffMaxLen, cVAList *vl, const wchar_t *pattern );
extern wchar_t *FormatT( wchar_t *buff, int buffMaxLen, const wchar_t *pattern, ... );
extern const int maxFormatLen; //  = 2048;

