/////////////////////////////////////////////////////////////////
//
//	Copyright (c) 1994-2011 Jetico, Inc., Finland
//	All rights reserved.
//
//	File: GetTempPathIH.h
//
//	Created: 26.07.2013
//	Description: Uses thread impersonated token to get real temp path for the impersonated user.
//
/////////////////////////////////////////////////////////////////

#pragma once 

#include <windows.h>

//
//	GetTempPathIH
//		The standard call GetTempPathT for non impersonated thread returns "C:\Users\PAV~1.BC_\AppData\Local\Temp\", but 
//		for impersonated thread returns 'C:\Windows\Temp'.
//		It was assumed that impersonated thread get temp path for the impersonated user.
//		So we use GetUserTempPath_ByImpersonatedToken here. It reads impersonated user registry, for shell folders and expand the environment string for him.
//		As result impersonated thread gets same path as GetTempPathT returns for simple user.
//
DWORD GetTempPathIH(
    DWORD nBufferLength,
    LPWSTR lpBuffer,
	bool doNotCreate = false
    );
