#include "cDlg.h"
#include <windowsx.h>
//#include "resource.h"
#include "..\CertificateLib\SMemory\SBlocks.h"
#include <stdio.h>
#include <assert.h>
#include <commctrl.h>
#include <io.h>
#include "TranslateDll.h"
#include "ODS.h"


//bool cDlg::m_useCtxAsIDS = false;

LRESULT cDlg::RealDlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if ( uMsg == WM_COMMAND )
	{
		EndDialog( m_hDlg, LOWORD( wParam ) );
		return true;
	}

	return false;
}

bool cDlgBase::OnInitPopupMenu( HMENU hMenu, WORD uSubMenu, BOOL isWindowMenu )
{
    HMENU hmPopup = hMenu; //GetSubMenu( hMenu, uSubMenu );
	
	if ( hmPopup == NULL )
	{ ODS_fls( L"Assertion!" ); return false; }

#ifdef _DEBUG
	wchar_t bf[100];
	GetMenuTextT( hMenu, uSubMenu, true, bf, maxLen( bf ) );
#endif

	int Q = GetMenuItemCount( hmPopup );

	for( int i = 0; i < Q; i++ )
	{
		UINT id = GetMenuItemID( hmPopup, i );
		if ( id == -1 )
		{ ODS_fls( L"Assertion!" ); continue; }

		OnUpdatePopupMenuItem( hmPopup, id );
	}

	return true;
}

LRESULT cDlgBase::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	if ( ( uMsg >= m_wmUser_first ) && ( uMsg <= m_wmUser_last ) )
		return UserMessage( uMsg, wParam, lParam );

	switch ( uMsg )
	{
		case WM_NOTIFY:
			return SetWindowLongPtrT( m_hDlg, DWLP_MSGRESULT, OnNotify((NMHDR *)lParam));

		case WM_COMMAND:
			// If an application processes this message, it should return zero.
			return OnCommand(  wParam, lParam );

		case WM_INITDIALOG:
		{
			m_sizedCtrls.Init( m_hDlg );

			// Return TRUE to direct the system to set the keyboard focus to the control specified by wParam
			bool ok = InitDialog();
			return ok;

		}
		case WM_SIZE:
			UpdateCaption();
			m_sizedCtrls.OnSize( lParam );
			OnSize( LOWORD( lParam ), HIWORD( lParam ) );
			break;

		case WM_DESTROY: 
			return OnDestroy();

		case WM_HELP:
			OnHelpInfo( (HELPINFO*)lParam );
			break;

		case WM_VSCROLL:
			return OnScroll( true, HWND(lParam), HIWORD( wParam ), LOWORD( wParam ) );
		case WM_HSCROLL:
			return OnScroll( false, HWND(lParam), HIWORD( wParam ), LOWORD( wParam ) );
		case WM_INITMENUPOPUP:
			return OnInitPopupMenu( (HMENU)wParam, LOWORD( lParam ), HIWORD( lParam ) );

		default:
			break;
	}

	return FALSE;
}

//
//	FillRect_WithGradient
//		Notes!  If you are goung to draw a text above the gradiented background:
//			1. Catch the WM_CTLCOLORSTATIC message and use SetBkMode( (HDC(wParam), TRANSPARENT ) for the item.
//			2. The text control has to be Left Alligned and has attribute SIMPLE, otherwise it is never drawing as transparent.
//
bool FillRect_WithGradient( HDC hdc,  RECT *r, COLORREF crStart, COLORREF crFinish, DWORD dwMode ) // dwMode = GRADIENT_FILL_RECT_H )
{
	if ( crStart == crFinish )
	{
		HBRUSH hBrush = CreateSolidBrush( crStart );
		bool ok = FillRect( hdc, r, hBrush ) != 0;
		DeleteObject( hBrush );
		return ok;
	}

	static CDll msImgDll( false, "Msimg32.dll", "GradientFill", false );

	if ( msImgDll.error )
		return false;

	typedef WINGDIAPI BOOL  WINAPI typeGradientFill( IN HDC, IN PTRIVERTEX, IN ULONG, IN PVOID, IN ULONG, IN ULONG);
	typeGradientFill *progGradientFill = ( typeGradientFill * )msImgDll.pProc;

	if ( dwMode == GRADIENT_FILL_TRIANGLE )
	{
		TRIVERTEX        vert[4];
		GRADIENT_TRIANGLE    gTri[2];

		vert [0] .x       =  r->left; // 0;
		vert [0] .y       =  r->top;  // 0;
		vert [0] .Red    = GetRValue( crStart ) << 8;
		vert [0] .Green  = GetGValue( crStart ) << 8;
		vert [0] .Blue   = GetBValue( crStart ) << 8;
		vert [0] .Alpha   =  0x0000;

		vert [1] .x       =  r->right; //100;
		vert [1] .y       =  r->top; //0;
		vert [1] .Red    = GetRValue( crFinish ) << 8;
		vert [1] .Green  = GetGValue( crFinish ) << 8;
		vert [1] .Blue   = GetBValue( crFinish ) << 8; // 0xff00;
		vert [1] .Alpha   =  0x0000;

		vert [2] .x       =  r->right; //100;
		vert [2] .y       =  r->bottom; //32; 
		vert [2] .Red    = GetRValue( crFinish ) << 8;
		vert [2] .Green  = GetGValue( crFinish ) << 8;
		vert [2] .Blue   = GetBValue( crFinish ) << 8; // 0xff00;
		vert [2] .Alpha   =  0x0000;

		vert [3] .x       =  r->left; //0;
		vert [3] .y       =  r->bottom; // 32;
		vert [3] .Red    = GetRValue( crFinish ) << 8;
		vert [3] .Green  = GetGValue( crFinish ) << 8;
		vert [3] .Blue   = GetBValue( crFinish ) << 8; // 0xff00;
		vert [3] .Alpha   =  0x0000;

		gTri[0].Vertex1   = 0;
		gTri[0].Vertex2   = 1;
		gTri[0].Vertex3   = 3; //2;

		gTri[1].Vertex1   = 1;//0;
		gTri[1].Vertex2   = 2;
		gTri[1].Vertex3   = 3;

		return progGradientFill( hdc, vert, 4, gTri, 2, GRADIENT_FILL_TRIANGLE ) != FALSE;
	}

	TRIVERTEX        vert[2];
	GRADIENT_RECT    gRect;
	vert [0] .x      = r->left;
	vert [0] .y      = r->top;
	vert [0] .Red    = GetRValue( crStart ) << 8;
	vert [0] .Green  = GetGValue( crStart ) << 8;
	vert [0] .Blue   = GetBValue( crStart ) << 8;
	vert [0] .Alpha  = 0x0000;

	vert [1] .x      = r->right;
	vert [1] .y      = r->bottom; 
	vert [1] .Red    = GetRValue( crFinish ) << 8;
	vert [1] .Green  = GetGValue( crFinish ) << 8;
	vert [1] .Blue   = GetBValue( crFinish ) << 8; // 0xff00;
	vert [1] .Alpha  = 0x0000;

	gRect.UpperLeft  = 0;
	gRect.LowerRight = 1;

	return progGradientFill( hdc, vert, 2, &gRect, 1, dwMode ) != FALSE;
}

void cColoredDlg::ResizeByText( HWND hText, DWORD swpFlag )
{
	cRect r;
	GetDlgItemRect( hText, &r );

	cSize size( &r );
	size.cy += 1000;

	cWCStr wcsText;
	wcsText.GetWindowTextT( hText );

	if ( GetTextSize( m_hDlg, wcsText.m_szBody, &size, (int)0 ) )
	{
		if ( size.cx > r.Width() )
		{
			size.GetSize( &r );
			size.cx += m_cxAdd; // 100;
			size.cy += 1000;
			GetTextSize( m_hDlg, wcsText.m_szBody, &size, DT_WORDBREAK );
		}

		SIZE d = { 0, 0 };
		d.cx = max( 0, size.cx - r.Width() );
		d.cy = size.cy - r.Height();

		GetWindowRect( m_hDlg, &r );

		if ( ( d.cx != 0 ) || ( d.cy != 0 ) )
			SetWindowPos( m_hDlg, HWND_TOP, r.left - d.cx/2 , r.top - d.cy /2, r.Width() + d.cx, r.Height() + d.cy, swpFlag );
	}
}

bool cColoredDlg::m_bDisbleColoring = false;

LRESULT cColoredDlg::DrawColorProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if ( m_bDisbleColoring || !m_changeBkColor )
		return 0;

	int dlgColor = COLOR_WINDOW;

	switch ( uMsg )
	{
		case WM_CTLCOLORSTATIC:
		{
			if ( m_lineRect.top == 0 )
				break;	// Line was not assigned
			else
			if ( m_lineRect.top > 0 )
			{
				RECT itemRect;
				cDlg::GetDlgItemRect( m_hDlg, (HWND)lParam, &itemRect );

				// Skips the items lay below line.
				if ( itemRect.top > m_lineRect.top )
					break;
			}

			// Change text and bg colors.

			HWND hBoldText = GetItem( m_idcBold );
			if ( hBoldText != NULL )
			{
				if ((LPARAM)hBoldText == lParam )
					SelectFont( (HDC)wParam, m_largeBold ? m_boldFont : m_boldFontMin );
			}
			else
			{
				hBoldText = GetDlgItem( m_hDlg, m_idcTitle );

				if ((LPARAM)hBoldText == lParam )
					SelectFont( (HDC)wParam, m_titleFont );
			}

			SetItemTextColor( (HDC)wParam, (HWND)lParam );
		
			int prev = SetBkMode( (HDC)wParam, TRANSPARENT );
			assert( GetBkMode( (HDC)wParam ) == TRANSPARENT );
			return (LRESULT)GetSysColorBrush( dlgColor );
		}

		case WM_INITDIALOG:
		{
			if ( m_dlgRect && ( m_dlgRect->left != 0 ) )
				SetWindowPos( m_hDlg, NULL,
					m_dlgRect->left,
					m_dlgRect->top,
					0, 0, SWP_NOSIZE );

			HWND hLine = GetDlgItem( m_hDlg, m_idcLine );

			if ( hLine != NULL )
				cDlg::GetDlgItemRect( m_hDlg, hLine, &m_lineRect );
			else
			{
				GetWindowRect( m_hDlg, &m_lineRect );
				m_lineRect.top = m_lineRect.bottom;
				//m_changeBkColor = false;
			}

			if ( m_idcHead != 0 )
			{
				HWND hHdr = GetDlgItem( m_hDlg, m_idcHead );
				if ( hHdr )
				{
					RECT rD, rH;
					GetClientRect( m_hDlg, &rD );
					cDlg::GetDlgItemRect( m_hDlg, hHdr, &rH );

					// Moves header to upper right corner
					if ( hLine == NULL )
						SetWindowPos( hHdr, 0, ( rD.right - rD.left ) - ( rH.right - rH.left ), 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER );
					else
					{
						RECT r;
						cDlg::GetDlgItemRect( m_hDlg, hLine, &r );

						// Moves idcLine item nearly to header
						if ( rH.bottom - rH.top > r.top )
						{
							SetWindowPos( hHdr, 0, ( rD.right - rD.left ) - ( rH.right - rH.left ), 0, 0, 0, SWP_NOSIZE | SWP_NOZORDER );

							// Moves line downto header and extend upto all dialog size 
							SetWindowPos( hLine, 0, 0, ( rH.bottom - rH.top ), rD.right - rD.left, r.bottom - r.top, SWP_NOZORDER );
						}
						else
						{
							// Moves header image between dilog caption and line 
							int y = ( r.top - ( rH.bottom - rH.top ) ) / 2;
							int x = ( rD.right - rD.left ) - ( rH.right - rH.left ) - y;
							SetWindowPos( hHdr, 0, x, y, 0, 0, SWP_NOSIZE | SWP_NOZORDER );

							// Extend line upto all dialog size
							SetWindowPos( hLine, 0, 0, r.top, rD.right - rD.left, r.bottom - r.top, SWP_NOZORDER );
						}
					}
				}
			}

			// Usualy dialog editor does not allow to create line control upto all dialog size
			// So the trick slightly extends the line control.
			if ( hLine != NULL )
			{
				RECT r;
				GetWindowRect( hLine, &r );
				int cx = r.right - r.left;
				int cy = r.bottom - r.top;

				DWORD dwStyle = GetWindowStyle( hLine );
				bool bVisible = ( dwStyle & WS_VISIBLE  ) != 0;

				SetWindowPos( hLine, NULL, 0, 0, cx + 6, cy, SWP_NOMOVE | (bVisible ? SWP_SHOWWINDOW : 0 ) );
			}

			if ( m_idiIcon != 0 )
				SetDlgIcon( m_idiIcon );

			m_sizedCtrls.Init( m_hDlg );

			if ( m_titleFont == NULL )
			{
				HDC hDC = GetDC( m_hDlg );

				CreateFonts( hDC );

				ReleaseDC( m_hDlg, hDC );
			}

			if ( m_caption != NULL )
				SetWindowTextT( m_hDlg,  m_caption );

			break;
		}
		case WM_DESTROY:
		{
			if ( m_dlgRect )
				GetWindowRect( m_hDlg, m_dlgRect );

			break;
		}

		case WM_SIZE:
		{
			m_sizedCtrls.OnSize( lParam );
			break;
		}

		case WM_ERASEBKGND:
		{
			if ( m_lineRect.top == 0 )
				break;	// Line was not assigned

			RECT r;
			GetClientRect( m_hDlg, &r );
			FillRect( (HDC)wParam, &r, GetSysColorBrush( COLOR_BTNFACE ) );

			if ( m_lineRect.top != 0 )
				r.bottom = m_lineRect.top;

			FillRect( (HDC)wParam, &r, GetSysColorBrush( dlgColor ) );

			bool bDrawLine = true;
			if ( bDrawLine )
			{
				RECT rLine = r;
				rLine.top = r.bottom;
				rLine.bottom += 1;
				FillRect( (HDC)wParam, &rLine, GetSysColorBrush( COLOR_INACTIVECAPTION ) );
			}

			if ( m_gradientMax != 0 )
				r.right = r.left + m_gradientMax;	

			// COLORREF crStart = RGB( 0x40, 0x80, 0x40 ); //::GetSysColor( 27 );
			if ( ( m_crStart == 0 ) ||
				!FillRect_WithGradient( (HDC)wParam, &r, m_crStart, ::GetSysColor( dlgColor ), GRADIENT_FILL_TRIANGLE ) ) 
					FillRect( (HDC)wParam, &r, GetSysColorBrush( dlgColor ) );

			return 1;
		}
	}

	return 0;
}

cDlg *cDlg::GetDlgClass( HWND hDlg )
{
	cDlg *dlg = (cDlg *)GetWindowLongPtrT(hDlg, DWLP_USER );

	if ( ( dlg != NULL ) && ( dlg->m_hDlg != hDlg ) )
	{
		assert( false );
	}

	return dlg;
}

void cDlg::SetDlgClass( HWND hDlg, cDlg *dlg )
{
	SetWindowLongPtrT( hDlg, DWLP_USER, LPARAM( dlg ));
}

int getHeight( HDC hdc, const wchar_t *text, DWORD dwDTParam )
{
	cRect r;
	r.right += r.left + 1000;
	r.bottom += r.top + 1000;
	DrawTextT( hdc, text, -1, &r, DT_CALCRECT | dwDTParam  );

	return r.Height();
}

bool cDlg::GetTextSize( HDC hdc, const wchar_t *text, SIZE *s, DWORD dwDTParam, HFONT hFont )
{
	SelectFont( hdc, hFont );

	cRect r;
	r.right += r.left + s->cx;
	r.bottom += r.top + s->cy;
	DrawTextT( hdc, text, -1, &r, DT_CALCRECT | dwDTParam  );

	s->cx = r.Width();
	s->cy = r.Height();

	return true;
}

bool cDlg::GetTextSize( HWND hDlg, const wchar_t *text, SIZE *s, DWORD dwDTParam, HFONT hFont )
{
	bool ok = false;

	HDC hdc = GetDC( hDlg );
	if ( hdc == NULL )
	{
		assert( false );
	}
	else
		ok = GetTextSize( hdc, text, s, dwDTParam, hFont );

	ReleaseDC( hDlg, hdc );

	return ok;
}

void cDlg::CheckAndEnableItem( int id, bool bCheck, bool bEnable )
{
	Button_SetCheck( GetItem( id ), bCheck ? BST_CHECKED : BST_UNCHECKED );
	EnableWindow( GetItem( id ), bEnable );
}

bool cDlg::GetTextSize( HWND hDlg, const wchar_t *text, SIZE *s, DWORD dwDTParam  ) // = DT_WORDBREAK )
{
	bool ok = false;

	NONCLIENTMETRICS info = { 0 };

#if(WINVER >= 0x0600)
	info.cbSize = sizeofBefore( NONCLIENTMETRICS, iPaddedBorderWidth );// Windows XP size.
#else
	info.cbSize = sizeof(info);
#endif

	BOOL bRet = ::SystemParametersInfo( SPI_GETNONCLIENTMETRICS, sizeof(info), &info, 0 );
	if ( !bRet )
	{
		assert( false );
		return false;
	}
	else
	{
		HFONT hFont = ::CreateFontIndirect( &info.lfMessageFont );

		assert( hFont != NULL );
		if( hFont == NULL )
			return false;

		ok = GetTextSize( hDlg, text, s, dwDTParam, hFont );

		DeleteObject( hFont );
	}

	return ok;
}

class sEnableItems
{
public:

	HWND m_hDlg;
	int m_posAfter;
	int m_posBefore;
	bool m_bEnable;
	
	sEnableItems()
	{
		m_hDlg = NULL;
		m_posAfter = 0;
		m_posBefore = 0;
		m_bEnable = false;
	}

	static BOOL CALLBACK staticEnumProc( HWND hWnd, LPARAM lParam )
	{
		sEnableItems *pThis = (sEnableItems *)lParam;

		if ( pThis == NULL )
			return false;

		return pThis->enumProc( hWnd );
	}

	bool enumProc( HWND hWnd )
	{
		RECT r;
		cDlg::GetDlgItemRect( m_hDlg, hWnd, &r );

#ifdef _DEBUG
		cWCStr wcs;
		wcs.GetWindowTextT( hWnd );
#endif

		// Does not touch elements beyond.
		if ( r.top		< m_posAfter	) return true;
		if ( r.bottom	> m_posBefore	) return true;
		
		// Upadtes the encluded element.
		EnableWindow( hWnd, m_bEnable );
		
		return true;
	}
};

//
//	DlgEnableItems
//	Enumerates dialog items and update the all placed 
//	after idAfter bottom but before idBefore top positions.
//
bool DlgEnableItems( HWND hDlg, int idAfter, int idBefore, bool bEnable )
{
	HWND hAfter  = GetDlgItem( hDlg, idAfter );
	HWND hBefore = GetDlgItem( hDlg, idBefore );

	if ( hAfter  == NULL ) return false;
	if ( hBefore == NULL ) return false;

	RECT rAfter, rBefore;
	cDlg::GetDlgItemRect( hDlg, hAfter, &rAfter );
	cDlg::GetDlgItemRect( hDlg, hBefore, &rBefore );

	sEnableItems sei;
	sei.m_bEnable	= bEnable;
	sei.m_hDlg		= hDlg;
	sei.m_posAfter	= rAfter.bottom;
	sei.m_posBefore = rBefore.top;

	EnumChildWindows( hDlg, sEnableItems::staticEnumProc, (LPARAM)&sei );

	return true;
}

//static 
bool cDlg::Redirect_ClickToCmd( HWND hDlg, UINT uMsg, int idc, LPARAM lParam  )
{
	if ( uMsg != WM_NOTIFY )
		return false;

	if (((LPNMHDR)lParam)->code == NM_CLICK )
	{
		if ((((LPNMHDR)lParam)->idFrom == idc ) )
		{
			PostMessage( hDlg, WM_COMMAND, idc, 0 );
			return true;
		}
	}

	return false;
}


LRESULT CALLBACK cDlg::DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	//ODSFuncS( _FormatT( L"%X, %X, %X, %X", hDlg, uMsg, wParam, lParam ) );
	cDlg *pThis = NULL;
	
	if ( uMsg != WM_INITDIALOG )
		pThis = GetDlgClass(hDlg);
	else
	if ( GetParent( hDlg ) == NULL )
		CenterPosition( hDlg );

	if ( uMsg == WM_NOTIFYFORMAT )
 		return NFR_UNICODE;
	
	if ( uMsg == WM_INITDIALOG )
	{
#ifndef _NoTranslation_
		if ( pTranslateDll != NULL )
			pTranslateDll->TranslateDialog( hDlg ); // Flip is disabled for properly sizing ( proprties of langFile.dll )
#endif

		pThis = (cDlg *)lParam;
		pThis->m_hDlg = hDlg;
		SetDlgClass( hDlg, pThis );

		RECT r;
		GetWindowRect( hDlg, &r );
		pThis->m_minSize.x = r.right - r.left;
		pThis->m_minSize.y = r.bottom - r.top;
		pThis->m_maxSize = pThis->m_minSize;

		pThis->m_trackingFixType = ttfMinX | ttfMinY;
	}
	else if ( uMsg == WM_GETMINMAXINFO )
	{
		MINMAXINFO *p = (MINMAXINFO *)lParam;

		if ( pThis == NULL ) { ODS_fls( L"pThis == NULL" ); return FALSE; }
		if ( lParam == NULL ) { ODS_fls( L"lParam == NULL" ); return FALSE; }

		if ( pThis->m_trackingFixType != ttfNone )
		{
			if ( pThis->m_trackingFixType & ttfMinX )
				p->ptMinTrackSize.x = pThis->m_minSize.x;
			if ( pThis->m_trackingFixType & ttfMinY )
				p->ptMinTrackSize.y = pThis->m_minSize.y;

			if ( pThis->m_trackingFixType & ttfMaxX )
				p->ptMaxTrackSize.x = pThis->m_maxSize.x;
			if ( pThis->m_trackingFixType & ttfMaxY )
				p->ptMaxTrackSize.y = pThis->m_maxSize.y;

			return 0;
		}
	}
	else if (!pThis)
	{
		return FALSE;
	}

	LRESULT res = pThis->DrawColorProc( uMsg, wParam, lParam );
	if ( res != 0 )
		return res;

//
//	New flip dialog strategy. See FlipDlgResource function description.
//
//#ifndef _NoTranslation_
//	if ( ( uMsg == WM_INITDIALOG ) && ( pTranslateDll != NULL ) )
//		pTranslateDll->FlipDialog( hDlg );
//#endif

	if ( ( uMsg == WM_NCLBUTTONDOWN ) &&
		 pThis->m_bCallHelpInfoByClickingCtxHelpButton &&
		 pThis->CtxHelp_NCLBUTTONDOWN( lParam ) )
	{
		pThis->OnHelpInfo();
		return 0;
	}

	LRESULT ok;
	
	if ( pThis->m_externalDlgProc != NULL )
		ok = CallWindowProcT( (WNDPROC)pThis->m_externalDlgProc, hDlg, uMsg, wParam, lParam );
	else
		ok = pThis->RealDlgProc( uMsg, wParam, lParam );

	return ok;
}

LRESULT CALLBACK cDlg::DlgPropPageProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	cDlg *pThis = GetDlgClass(hDlg);

	if (uMsg == WM_INITDIALOG)
	{
#ifndef _NoTranslation_
		if ( pTranslateDll != NULL )
			pTranslateDll->TranslateDialog( hDlg );
#endif

		pThis = (cDlg *)((PROPSHEETPAGE *)lParam)->lParam;
		pThis->m_hDlg = hDlg;
		SetDlgClass( hDlg, pThis );
	}
	else if (!pThis)
	{
		return FALSE;
	}

	return pThis->RealDlgProc( uMsg, wParam, lParam );
}

//
//	FlipDlgResource. New strategy.
//	Reads dialog resource by ID and flips it if translateDll->m_flipdialog is assigned
//	It is required because old strategy ( flipping by langFile.dll fuinction in WM_INITDIALOG )
//	does not work properly for Farsi or Arabic translations. Seems it was too late for correct flipping.
//
LPDLGTEMPLATEW cDlg::FlipDlgResource( UINT idRes )
{
	HRSRC hRC = m_isNT ? 
		FindResourceW( m_hInst, MAKEINTRESOURCEW(idRes), (LPWSTR)RT_DIALOG ):
		FindResourceA( m_hInst, MAKEINTRESOURCEA(idRes), (LPSTR)RT_DIALOG );

	if ( hRC == NULL )
		return NULL;

	HGLOBAL hGlb = LoadResource( m_hInst, hRC );

	if ( hGlb == NULL )
		return NULL;

	void *ptr = LockResource( hGlb );

	if ( ptr == NULL )
		return NULL;

	int size = SizeofResource( m_hInst, hRC ); 

	LPDLGTEMPLATEW hDialogTemplate = (LPDLGTEMPLATEW)m_adbfRC.AllocateAndCopy( (BYTE*)ptr, size );

	FreeResource( hGlb );

	if ( hDialogTemplate == NULL )
		return NULL;

#ifndef _NoTranslation_

#ifndef WS_EX_LAYOUTRTL
#define WS_EX_LAYOUTRTL 0x00400000L
#endif

	if ( ( pTranslateDll != NULL ) && pTranslateDll->m_flipDialog )
	{
		DLGTEMPLATEEX *hDialogTemplateEx = (DLGTEMPLATEEX *)hDialogTemplate;

		DWORD styleAdd = ( WS_EX_LAYOUTRTL ); // WS_EX_RTLREADING | 

		if ( hDialogTemplateEx->signature == 0xFFFF ) // Is DLGTEMPLATEEX structure
		{
			hDialogTemplateEx->exStyle |= styleAdd;
		}
		else
			hDialogTemplate->dwExtendedStyle |= styleAdd;
	}
#endif // _NoTranslation_
	
	return hDialogTemplate;
}

INT_PTR cDlg::DoModal( HINSTANCE hInst, UINT idRes, HWND hParent, DLGPROC externalDlgProc )
{
	m_idd = idRes;
	m_hInst = hInst;

	m_externalDlgProc = externalDlgProc;

	LPDLGTEMPLATEW hDialogTemplate = FlipDlgResource( idRes );
		
	if ( hDialogTemplate == NULL )
	{
		ODS_fls( _FormatT( L"Assertion! %s", _GetSystemError(-1) ) );
		return INT_PTR(-1);
	}

	if ( !m_isNT )
	{
		ODS_fls( L"Assertion! Is not Windows NT!" );
		// return DialogBoxParamA( m_hInst, MAKEINTRESOURCEA(idRes), hParent, (DLGPROC)DlgProc, (LPARAM)this );
	}
	
	INT_PTR res = DialogBoxIndirectParamW( m_hInst, hDialogTemplate, hParent, (DLGPROC)DlgProc, (LPARAM)this );

	DWORD err = GetLastError();

	if ( res == (INT_PTR)-1 )
	{
		ODS_fls( _FormatT( L"Assertion! Error in starting dialog - %s, hParent %X", _GetSystemError( err ), hParent ) );

		if ( err != 0 )
		{
			res = DialogBoxParamA( m_hInst, MAKEINTRESOURCEA(idRes), hParent, (DLGPROC)DlgProc, (LPARAM)this );
			err = GetLastError();
			
			if ( res == (INT_PTR)-1 )
			{
				ODS_fls( _FormatT( L"Assertion! Error in starting dialog - %s, hParent %X", _GetSystemError( err ), hParent ) );

				if ( err != 0 )
					MessageBoxT( NULL, _GetSystemError( err ), L"Errror in creating dialog!", MB_ICONERROR );
			}
		}
	}

	SetLastError( err );

	return res;
}


HWND cDlg::DoModeless( HINSTANCE hInst, UINT idRes, HWND hParent, DLGPROC externalDlgProc )
{
	m_idd = idRes;

	m_hInst = hInst;
	m_autoDestroy = true;

	m_externalDlgProc = externalDlgProc;

	LPDLGTEMPLATEW hDialogTemplate = FlipDlgResource( idRes );

	if ( hDialogTemplate == NULL )
		return NULL;

	return
		m_isNT ?
			CreateDialogIndirectParamW( m_hInst, hDialogTemplate, hParent, (DLGPROC)DlgProc, (LPARAM)this) :
			CreateDialogParamA( m_hInst, MAKEINTRESOURCEA(idRes), hParent, (DLGPROC)DlgProc, (LPARAM)this);
}

HWND cDlg::DoModelessPage( HINSTANCE hInst, UINT idRes, HWND hParent )
{
	return DoModeless( hInst, idRes, hParent );
}

bool cDlg::setWindowRect( RECT &r )
{
	if ( !BelongToScreen( (POINT*)&r,2 ) )
		CenterPosition( &r );

	return ::SetWindowPos( m_hDlg, 0, r.left, r.top, r.right - r.left, r.bottom - r.top, SWP_NOZORDER | SWP_SHOWWINDOW ) == TRUE;
}

//static
bool cDlg::BelongToScreen( POINT *ptT, int ptQ, int delta )
{
	while( ptQ-- )
	{
		if ( ptT[ ptQ ].x < delta ) return false;
		if ( ptT[ ptQ ].y < delta ) return false;
		if ( ptT[ ptQ ].x >= GetSystemMetrics( SM_CXSCREEN ) - delta ) return false; 
		if ( ptT[ ptQ ].y >= GetSystemMetrics( SM_CYSCREEN ) - delta ) return false;
	}

	return true;
}

//static 
void cDlg::CenterPosition( RECT *r, int px, int py )
{
		// Get Dialog Window Width and Height.
	int nDialogWidth = r->right - r->left;
	int nDialogHeight = r->bottom - r->top;

		// Get Screen Width and Height.
	int nScreenWidth  = GetSystemMetrics( SM_CXSCREEN );
	int nScreenHeight = GetSystemMetrics( SM_CYSCREEN );

		// Modify the position of the Window.
	r->left   = (nScreenWidth - nDialogWidth ) * px / 100;
	r->top    = (nScreenHeight -  nDialogHeight ) * py / 100;

	r->left	= min(r->left,(nScreenWidth - nDialogWidth - 10));
	r->top	= min(r->top ,(nScreenHeight - nDialogHeight - 10));

	r->right  = r->left + nDialogWidth;
	r->bottom = r->top + nDialogHeight;
}

// static
void cDlg::CenterPosition( HWND hDlg, int px, int py )
{
	RECT rect;
	GetWindowRect( hDlg, (LPRECT) &rect );

	CenterPosition( &rect, px, py );

	// Move the Dialog Window in center of the screen.
	MoveWindow(
		hDlg ,
		rect.left,
		rect.top,
		rect.right - rect.left,
		rect.bottom - rect.top,
		TRUE);
}

// static
void cDlg::MoveWindowToCursorPosition( HWND hDlg )
{
	POINT p = { 0, 0 };

	if ( ( p.x == 0 ) && ( p.y == 0 ) )
	{
		GetCursorPos( &p );
		p.y -= 80; 
		p.x -= 60;
		if ( p.y < 0 ) p.y = 0;
		if ( p.x < 0 ) p.x = 0;
	}

	SetWindowPos( hDlg, HWND_TOP , p.x, p.y, 0, 0, SWP_NOSIZE );

	RECT r;
	GetWindowRect( hDlg, &r );
}

// static
void cDlg::MapToScreen( HWND hDlg )
{
	RECT r;
	GetWindowRect( hDlg, &r );

    // Get Screen Width and Height.
	int nScreenWidth  = GetSystemMetrics( SM_CXSCREEN );
	int nScreenHeight = GetSystemMetrics( SM_CYSCREEN );

	int delta = 5;

	if ( nScreenHeight - delta < r.bottom )
		r.top = nScreenHeight - delta - ( r.bottom - r.top );

	if ( nScreenWidth - delta < r.right )
		r.left = nScreenWidth - delta - ( r.right - r.left );

	if ( r.left < delta ) 
		r.left = delta;

	if ( r.top < delta )
		r.top = delta;

	SetWindowPos( hDlg, HWND_TOPMOST, r.left, r.top, 0, 0, SWP_NOSIZE ); //  | SWP_NOZORDER 
}


//
//	Class cSizedCtrls, it can be a cDialog member.
//

cSizedCtrls::cSizedCtrls()
{
	memset( this, 0, sizeof( *this ) );
}

cSizedCtrls::~cSizedCtrls()
{
	cCtrl *t;

	while( head )
	{
		t = head->next;
		delete head;
		head = t;
	}
}


void cSizedCtrls::AddBelow( HWND hDlg, HWND hWnd )
{
	class cAddSizedControls: public cEnumDlgItem
	{
	public:

		HWND m_hDlg;
		RECT *m_pRect;
		cSizedCtrls *m_pCtrl;
		
		cAddSizedControls( cSizedCtrls *pCtrl, HWND hDlg, RECT *pRect )
		{
			m_pCtrl = pCtrl;
			m_hDlg = hDlg;
			m_pRect = pRect;
		}

		//
		//	findActor
		//		return false to stop enumeration.
		//
		virtual bool childActor( HWND hWnd )
		{
			RECT r;
			cDlg::GetDlgItemRect( m_hDlg, hWnd, &r );

			if ( r.bottom > m_pRect->bottom )
				m_pCtrl->AddCtrl( hWnd, cSizedCtrls::ptPDR );
			else
			if ( r.bottom == m_pRect->bottom )
				m_pCtrl->AddCtrl( hWnd, cSizedCtrls::ptSDR );

			return true;		
		}
	};

	Init( hDlg );

	RECT r;
	cDlg::GetDlgItemRect( hDlg, hWnd, &r );
	
	cAddSizedControls asc( this, hDlg, &r );

	asc.Walk( hDlg );
}

void cSizedCtrls::AddAll( HWND hDlg, ePosType pType, int *excludeT, int excludeQ )
{
	class cAddSizedControls: public cEnumDlgItem
	{
	public:

		HWND m_hDlg;
		ePosType m_pType;
		cSizedCtrls *m_pCtrl;
		int *m_excludeT;
		int m_excludeQ;
		
		cAddSizedControls( cSizedCtrls *pCtrl, HWND hDlg, ePosType pType, int *excludeT, int excludeQ )
		{
			m_pCtrl = pCtrl;
			m_hDlg = hDlg;
			m_pType = pType;
			m_excludeT = excludeT;
			m_excludeQ = excludeQ;
		}

		bool isExcluded( HWND hWnd )
		{
			int id = GetDlgCtrlID( hWnd );

			for( int i = m_excludeQ; i--; )
			{
				if ( m_excludeT[i] == id )
					return true;
			}

			return false;
		}

		//
		//	findActor
		//		return false to stop enumeration.
		//
		virtual bool childActor( HWND hWnd )
		{
			if ( !isExcluded( hWnd ) )
				m_pCtrl->AddCtrl( hWnd, m_pType );

			return true;		
		}
	};

	Init( hDlg );

	cAddSizedControls asc( this, hDlg, pType, excludeT, excludeQ );

	asc.Walk( hDlg );
}

void cSizedCtrls::Init( HWND hDlg ) //, HICON hIcon )
{
	m_hDlg = hDlg;

	RECT rect;
	GetClientRect( m_hDlg, &rect );
	m_x = rect.right - rect.left;
	m_y = rect.bottom - rect.top;

	GetClientRect( m_hDlg, &m_rOrig );

	cCtrl *ctrl = head;
	for( ; ctrl; ctrl = ctrl->next )
		UpdateItem( ctrl );
}

cSizedCtrls::cCtrl *cSizedCtrls::FindCtrl( HWND hWnd )
{
	cCtrl *ctrl = head;

	for ( ; ctrl; ctrl = ctrl->next )
	{
		if ( ctrl->hWnd == hWnd )
			break;
	}

	return ctrl;
}

//
//	AddCtrl
//		Allows to reassign element type ( see FindCtrl ).
//		It is useful if collective assigment function is used AddAll or AddBelow before.
//
void cSizedCtrls::AddCtrl( HWND hWnd, ePosType type )
{
	if ( type == ptNo )
		return;

	cCtrl *ctrl = FindCtrl( hWnd );

	if ( ctrl == NULL )
	{
		ctrl = new cCtrl();
		if ( ctrl == NULL )
			return;

		ctrl->hWnd = hWnd;
		ctrl->next = head;
		head = ctrl;
	}

	ctrl->pt = type;

	UpdateItem( ctrl );
}

void cSizedCtrls::UpdateItem( cCtrl *ctrl )
{
	RECT r;
	GetWindowRect( ctrl->hWnd, &r );
	POINT pos = { r.left, r.top };
	//ScreenToClient( m_hDlg, &pos );
	MapWindowPoints( NULL, m_hDlg, &pos, 1 );
	
	//
	//	Strange behaovior at W7.
	//	It decreases size of list view and moves it to left.
	//
	if ( pos.x == -1 )
	{
		pos.x++;
		r.left++;
		r.right += 3;
		RECT rx = r;
		MapWindowPoints( NULL, m_hDlg, (POINT*)&rx, 2 );
		BOOL res = SetWindowPos(
			ctrl->hWnd,
			NULL,
			rx.left,
			rx.top,
			rx.right - rx.left,
			rx.bottom - rx.top,
			SWP_NOZORDER
			);
	}

	ctrl->rOrig.left = pos.x;
	ctrl->rOrig.top = pos.y;

	POINT posRB = { r.right, r.bottom };
	//ScreenToClient( m_hDlg, &posRB );
	MapWindowPoints( NULL, m_hDlg, &posRB, 1 );

	ctrl->rOrig.right = posRB.x;
	ctrl->rOrig.bottom = posRB.y;

	switch ( ctrl->pt )
	{
		case ptPRSD :
			ctrl->dx = m_x - pos.x;
			ctrl->dy = m_y - ( r.bottom - r.top );
			break;
		case ptPDSR :
			ctrl->dx = m_x - ( r.right - r.left );
			ctrl->dy = m_y - pos.y;
			break;
		case ptPDR :
			ctrl->dx = m_x - pos.x;
			ctrl->dy = m_y - pos.y;
			break;
		case ptSDR :
			ctrl->dx = m_x - ( r.right - r.left );
			ctrl->dy = m_y - ( r.bottom - r.top );
			break;
		case ptPR :
			ctrl->dx = m_x - pos.x;
			ctrl->dy = pos.y;
			break;
		case ptSR :
			ctrl->dx = m_x - ( r.right - r.left );
			ctrl->dy = r.bottom - r.top;
			break;
		case ptPD :
			ctrl->dx = pos.x;
			ctrl->dy = m_y - pos.y;
			break;
		case ptSD :
			ctrl->dx = r.right - r.left;
			ctrl->dy = m_y - ( r.bottom - r.top );
			break;
	}
}

void cSizedCtrls::cCtrl::Show( bool show )
{
	if ( show )
	{
		// Does not show previously hidden window
		if ( !hidden )
			ShowWindow( hWnd, SW_SHOW );
	}
	else
	{
		hidden = ShowWindow( hWnd, SW_HIDE ) == 0;
	}
}

static void Show( cSizedCtrls::cCtrl *ctrl, int show )
{
	for( ; ctrl; ctrl = ctrl->next )
	{
		if ( show == 0 )
			ctrl->Show( false );
		else
		if ( show == 1 )
			ctrl->Show( true );
		else
		{
			ctrl->Show( false );
			ctrl->Show( true );
		}
	}
}

/*
void cSizedCtrls::OnSize( int x, int y )
{
	const SWP_Flags = SWP_NOZORDER;// | SWP_NOREDRAW;

	cCtrl *ctrl = head;

	Show( head, false );

	for( ; ctrl; ctrl = ctrl->next )
	{
		switch ( ctrl->pt )
		{
			case ptPRSD :
			{
				RECT r;
				GetWindowRect( ctrl->hWnd, &r );
				POINT pos = { r.left, r.top };
				ScreenToClient( m_hDlg, &pos );

				SetWindowPos(
					ctrl->hWnd,
					NULL,
					x - ctrl->dx,
					pos.y,
					r.right - r.left,
					y - ctrl->dy,
					SWP_Flags );
				break;
			}

			case ptPDSR :
			{
				RECT r;
				GetWindowRect( ctrl->hWnd, &r );
				POINT pos = { r.left, r.top };
				ScreenToClient( m_hDlg, &pos );

				SetWindowPos(
					ctrl->hWnd,
					NULL,
					pos.x,
					y - ctrl->dy,
					x - ctrl->dx,
					r.bottom - r.top,
					SWP_Flags );
				break;
			}
			case ptPDR :
				SetWindowPos(
					ctrl->hWnd,
					NULL,
					x - ctrl->dx,
					y - ctrl->dy,
					0,
					0,
					SWP_Flags | SWP_NOSIZE );
				break;
			case ptSDR :
				SetWindowPos(
					ctrl->hWnd,
					NULL,
					0,
					0,
					x - ctrl->dx,
					y - ctrl->dy,
					SWP_Flags | SWP_NOMOVE );
				break;
			case ptPR :
				SetWindowPos(
					ctrl->hWnd,
					NULL,
					x - ctrl->dx,
					ctrl->dy,
					0,
					0,
					SWP_Flags | SWP_NOSIZE );
				break;
			case ptSR :
				SetWindowPos(
					ctrl->hWnd,
					NULL,
					0,
					0,
					x - ctrl->dx,
					ctrl->dy,
					SWP_Flags | SWP_NOMOVE );
				break;
			case ptPD :
				SetWindowPos(
					ctrl->hWnd,
					NULL,
					ctrl->dx,
					y - ctrl->dy,
					0,
					0,
					SWP_Flags | SWP_NOSIZE );
				break;
			case ptSD :
				SetWindowPos(
					ctrl->hWnd,
					NULL,
					0,
					0,
					ctrl->dx,
					y - ctrl->dy,
					SWP_Flags | SWP_NOMOVE );
				break;
		}

	}

	if ( m_hDlg != NULL )
		ShowWindow( m_hDlg, SW_SHOW );

	if ( head != NULL )
		Show( head, true );
}


*/
void cSizedCtrls::OnSize( int x, int y )
{
	if ( IsIconic( m_hDlg ) )
		return;

	const DWORD SWP_Flags = SWP_NOZORDER | SWP_NOREDRAW | SWP_NOSENDCHANGING;

	cCtrl *ctrl = head;

	Show( head, false );

	int dx = x - m_x;
	int dy = y - m_y;

	for( ; ctrl; ctrl = ctrl->next )
	{
#ifdef _DEBUG
		wchar_t wndName[ 256 ];
		GetWindowTextT( ctrl->hWnd, wndName, maxLen( wndName ) );
#endif
		if ( ctrl->hWnd == NULL )
		{
			ODS_fls( L"Assertion!" );
			continue;
		}

		RECT r;
		GetWindowRect( ctrl->hWnd, &r );
		cDlg::ScreenToClientRect( m_hDlg, &r );

		if ( ( ( ctrl->r.right - ctrl->r.left ) < 0 ) ||
			 ( ( ctrl->r.bottom - ctrl->r.top ) < 0 )
			 )
				r = ctrl->r;

		bool rtl = r.left > r.right;

		if ( rtl )
		{
			r.left ^= r.right;
			r.right ^= r.left;
			r.left ^= r.right;
		}

		// Sizes
		if ( ctrl->pt & ptSR  )
		{
				r.right		+= dx;
			//	r.left		+= dx;
			//	r.top		+= dy;
			//	r.bottom	+= dy;
		}
		if ( ctrl->pt & ptSD  )
		{
			//	r.right		+= dx;
			//	r.left		+= dx;
			//	r.top		+= dy;
				r.bottom	+= dy;
		}

		// Positions
		if ( ctrl->pt & ptPR  )
		{
				r.right		+= dx;
				r.left		+= dx;
			//	r.top		+= dy;
			//	r.bottom	+= dy;
		}

		if ( ctrl->pt & ptPD )
		{
			//	r.right		+= dx;
			//	r.left		+= dx;
				r.top		+= dy;
				r.bottom	+= dy;
		}

		if ( ctrl->pt & ptPHC )
		{
			RECT rCur;
			GetClientRect( m_hDlg, &rCur );

			int curCenterX = ( rCur.right - rCur.left ) / 2;
			int origCenterX = ( m_rOrig.right - m_rOrig.left ) / 2;

			int posCenterX = ctrl->rOrig.left - origCenterX;

			r.left = curCenterX + posCenterX;

			if ( ctrl->pt & ptPSHC & ~ptPHC )
				r.right	+= dx;
			else
				r.right	= r.left + ( ctrl->rOrig.right - ctrl->rOrig.left );

			//	r.right		+= dx/2;
			//	r.left		+= dx/2;
			////	r.top		+= dy/2;
			////	r.bottom	+= dy/2;
		}
		else
		if ( ctrl->pt & ptSHC )
		{
			RECT rCur;
			GetClientRect( m_hDlg, &rCur );

			int curCenterX = ( rCur.right - rCur.left ) / 2;
			int origCenterX = ( m_rOrig.right - m_rOrig.left ) / 2;

			int posCenterX = ctrl->rOrig.right - origCenterX;

			r.right	= curCenterX + posCenterX;
		}

		if ( ctrl->pt & ptPVC )
		{
			//	r.right		+= dx/2;
			//	r.left		+= dx/2;
				r.top		+= dy/2;
				r.bottom	+= dy/2;
		}

//		ShowWindow( ctrl->hWnd, SW_HIDE );
		BOOL res = SetWindowPos(
			ctrl->hWnd,
			NULL,
			r.left,
			r.top,
			r.right - r.left,
			r.bottom - r.top,
			SWP_Flags
			);
//		ShowWindow( ctrl->hWnd, SW_SHOW );

		ctrl->r = r;

		assert( res );
	}

	m_x = x;
	m_y = y;

//	if ( m_hDlg != NULL )
//		ShowWindow( m_hDlg, SW_SHOW );

//	if ( head != NULL )
//		Show( head, 2 );

	if ( head != NULL )
		Show( head, true );
}



//static 
DWORDLONG cDlg::UpdateEditSize( HWND hEdit, int delta, int idsErr, int idsCaption )
{
	wchar_t text[ 256 ];
	GetWindowTextT( hEdit, text, maxLen( text ) );
	DWORDLONG dimention = 0;
	DWORDLONG val = GetSizeFromText( text, &dimention );

	if ( val == -1 )
	{
		if ( idsErr != 0 )
		{
			cWCStr caption;
			if ( idsCaption != 0 )
				caption.LoadIDS( idsCaption );
			else
				caption.Set( "Error!" );

			MessageBoxT( hEdit, _LoadIDS( idsErr ), caption.m_szBody, MB_ICONEXCLAMATION );
		}

		SetFocus( hEdit );
		return (DWORDLONG)-1;
	}

	DWORDLONG addSize = dimention; // /10;

	if ( delta > 0 )
		val += addSize;
	else
	if ( delta < 0 )
	{
		if ( val < addSize )
			val = 0;
		else
		if ( val == dimention )
		{
			if ( dimention == 1 )
				val = 0;
			else
				val = dimention - dimention / 1024;
		}
		else
			val -= addSize;
	}
	else
		return val;

	SetWindowTextT( hEdit, cWCStr().GetSizeText( val ) );

	return val;
}

bool cDlg::CtxHelp_NCLBUTTONDOWN( LPARAM lParam )
{
	RECT dlgRect;
	GetWindowRect( m_hDlg, &dlgRect );

	RECT ctxHelpButtonRect = dlgRect;
	
	ctxHelpButtonRect.top += - 0x04;
	ctxHelpButtonRect.bottom = ctxHelpButtonRect.top + 0x12;
	ctxHelpButtonRect.right -= 0x33;
	ctxHelpButtonRect.left = ctxHelpButtonRect.right - 0x1B;

	int xPos = GET_X_LPARAM(lParam);
	int yPos = GET_Y_LPARAM(lParam);

	return cRect::Belong( &ctxHelpButtonRect, xPos, yPos );
}

bool cDlg::UDNDeltapos( NMUPDOWN *ud, int id_edt, int pMin, int pMax, int pDelta )
{
	if ( ud->iDelta == 0 )
		return FALSE;

	bool up = ud->iDelta > 0; // If range has been set so we have to use up = ud->iDelta < 0

	int pos;
	wchar_t text[80];
	GetDlgItemTextT( id_edt, text, maxLen( text ) );
	pos = _wtoi( text );	

	int tail = pos % pDelta;
	pos -= tail;

	if ( !up )
	{
		tail = pDelta;
	}
	else
	{
		if ( tail )
			tail = 0;
		else
			tail = - pDelta;
	}

	pos = pos + tail;

	if ( pos < pMin )
		pos = pMin;
	else
	if ( pos > pMax )
		pos = pMax;

	::FormatT( text, maxLen( text ), L"%d", pos );
	SetDlgItemTextT( id_edt, text );

	return TRUE;
}

bool cDlg::UDNDeltapos( NMUPDOWN *ud, HWND hWnd, int pMin, int pMax, int pDelta )
{
	if ( ud->iDelta == 0 )
		return FALSE;

	bool up = ud->iDelta > 0; // If range has been set so we have to use up = ud->iDelta < 0

	int pos;
	wchar_t text[80];
	GetWindowTextT( hWnd, text, maxLen( text ) );
	pos = _wtoi( text );	

	int tail = pos % pDelta;
	pos -= tail;

	if ( !up )
	{
		tail = pDelta;
	}
	else
	{
		if ( tail )
			tail = 0;
		else
			tail = - pDelta;
	}

	pos = pos + tail;

	if ( pos < pMin )
		pos = pMin;
	else
	if ( pos > pMax )
		pos = pMax;

	::FormatT( text, maxLen( text ), L"%d", pos );
	SetWindowTextT( hWnd, text );

	return TRUE;
}

int ListView_GetItemIndent( HWND hList, int item )
{
	LVITEMW lvi;
	memset( &lvi, 0, sizeof( lvi ) );
	lvi.iItem = item;
	lvi.mask = LVIF_INDENT;

	ListView_GetItem( hList, &lvi );

	return lvi.iIndent;
}

LPARAM ListView_GetItemParam( HWND hLView, int itemNum )
{
	LVITEM lvi;
	memset( &lvi, 0, sizeof( lvi ) );

	lvi.mask = LVIF_PARAM;
	lvi.iItem = itemNum;

	ListView_GetItem( hLView, &lvi );

	return lvi.lParam;
}

void ListView_SetItemParam( HWND hLView, int itemNum, LPARAM param )
{
	LVITEM lvi;
	memset( &lvi, 0, sizeof( lvi ) );

	lvi.mask = LVIF_PARAM;
	lvi.lParam = param;
	lvi.iItem = itemNum;

	ListView_SetItem( hLView, &lvi );
}

void ListView_SetItemImage( HWND hLView, int itemNum, int imageNum )
{
	LVITEM lvi;

	memset( &lvi, 0, sizeof( lvi ) );
	lvi.mask = LVIF_IMAGE;
	lvi.iImage = imageNum;
	lvi.iItem = itemNum;

	ListView_SetItem( hLView, &lvi );
}

int ListView_GetItemImage( HWND hLView, int itemNum )
{
	LVITEM lvi;

	memset( &lvi, 0, sizeof( lvi ) );
	lvi.mask = LVIF_IMAGE;
	lvi.iItem = itemNum;

	if ( !ListView_GetItem( hLView, &lvi ) )
		return -1;

	return lvi.iImage;
}

class cFindNextDlgItem : public cEnumDlgItem
{
public:
	DWORD m_dwStyle;
	DWORD m_dwMask; // Se 'Masked style' comments below
	const char *m_className;
	int m_idFound;

	cFindNextDlgItem( const char *className = NULL, DWORD dwStyle = 0, DWORD dwMask = 0, int startFrom = 0 )
		: cEnumDlgItem( startFrom )
	{
		m_idFound	= 0;
		m_dwStyle	= dwStyle;
		m_dwMask	= dwMask;
		m_className	= className;
	}

	bool cFindNextDlgItem::childActor( HWND hWnd )
	{
		char szClass[ 64 ];

		if ( !GetClassNameA( hWnd, szClass, sizeof( szClass ) ) )
		{
			assert( false );
			return false; // Stop searching.
		}

		if ( m_className != NULL )
		{
			if ( _stricmp( szClass, m_className ) != 0 )
				return true; // Continue searching.
		}
		
		DWORD dwStyle = GetWindowStyle( hWnd );

		if ( m_dwMask != 0 ) // 'Masked style'
		{
			if ( ( dwStyle & m_dwMask ) != m_dwStyle )
				return true; // Continue searching.

			// Required compatible style.
			// F.e. 0x5 & 0x3 == 0x1
		}
		else // m_dwMask == 0, is not 'Masked style'
		{
			if ( ( dwStyle & m_dwStyle  ) != m_dwStyle )
				return true; // Continue searching.

			// Required compatible style.
			// F.e. 0x5 & 0x1 == 0x1
		}

		m_idFound = GetDlgCtrlID( hWnd );

		return false; // Stop searching.
	}
};

static int FindNextDlgID( HWND hDlg, const char *className, DWORD dwStyle, DWORD dwMask )
{
	cFindNextDlgItem fdi( className, dwStyle, dwMask );

	EnumChildWindows( hDlg, fdi.staticEnumChildProc, (LPARAM)&fdi );

	return fdi.m_idFound;
}

void DrawFileIcon( HWND hDlg, HDC dc, HICON hIcon, int id )
{
	if ( !hIcon )
		return;

	HWND hWnd = GetDlgItem( hDlg, id );

	assert( hWnd != NULL );

	if ( hWnd == NULL )
		return;

	//
	//	We'll draw icon at same place, so we have to hide the original window before.
	//
	ShowWindow( hWnd, SW_HIDE );

	RECT r;
	GetWindowRect( hWnd, &r );
	//POINT p = { r.left, r.top };
	// ScreenToClient( hDlg, &p );
	cDlg::ScreenToClientRect( hDlg, &r ); 
	POINT p = { r.left, r.top };
	DrawIcon( dc, p.x, p.y, hIcon );
}


LRESULT cChkDlg::RealDlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch(uMsg)
	{
		case WM_PAINT:
		{
			if ( m_hIcon != NULL )
			{
				HDC dc;
				PAINTSTRUCT ps;

				if ((HDC) wParam != NULL)
					dc = (HDC) wParam;
				else
					dc = BeginPaint( m_hDlg, &ps );

				DrawFileIcon( m_hDlg, dc, m_hIcon, m_idIcon );

				if ((HDC) wParam == NULL)
					EndPaint( m_hDlg, &ps );
			}

			//break;
			return FALSE;
		}

		case WM_INITDIALOG:
		{

			int i;

			for( i = m_strQ; i--; )
			{
				if ( m_strT[i].idc == 0 )
					continue;

				if ( m_strT[i].str != NULL )
					SetDlgItemTextT( m_strT[i].idc, m_strT[i].str );
				else
				if ( m_strT[i].ids != 0 )
					SetDlgItemTextT( m_strT[i].idc, _LoadIDS( m_strT[i].ids ) );
				else
				if ( m_formatTextQ != 0 )
				{
					cWCStr ptrn( 512 );
					GetDlgItemTextT( m_strT[i].idc, ptrn.m_szBody, ptrn.m_len );

					cWCStr bf;
					bf.FormatT( ptrn.m_szBody, m_formatTextT[0], m_formatTextT[1], m_formatTextT[2] );
					SetDlgItemTextT( m_strT[i].idc, bf.m_szBody );
				}
			}

			if ( m_chkQ == 0 )
			{
				m_singleChk.idc = FindNextDlgID( m_hDlg, "Button", BS_AUTOCHECKBOX, BS_TYPEMASK );

				if ( m_singleChk.idc != 0 )
				{
					m_singleChk.chk = false;
					m_chkQ = 1;
					m_chkT = &m_singleChk;
				}
			}

			for( i = m_chkQ; i--; )
			{
				m_bChk = m_chkT[i].chk;
				Button_SetCheck( GetDlgItem( m_hDlg, m_chkT[i].idc ), m_bChk ? BST_CHECKED : BST_UNCHECKED );
			}

			break;
		}

		case WM_COMMAND:
		{
			int i = m_chkQ;

			while( i-- )
			{
				if ( (int)wParam == m_chkT[i].idc )
				{
					m_bChk = Button_GetCheck( GetDlgItem( m_hDlg, m_chkT[i].idc ) ) == BST_CHECKED;
					m_chkT[i].chk = m_bChk;
					break;
				}
			}

			//
			// A command button has been pressed.
			//
			if ( i < 0 )
				EndDialog( m_hDlg, wParam );

			break;
		}

		default:
			return FALSE;
	}

	return TRUE;
}

static cAutoDeallocate < wchar_t > adHelpFilePath;
static bool isHtmlHelp = false;

//
//	Context help file is never used now, all ctx strings are moved to resources
//
////
////	Context help concept.
////		1. If lang file is assigned, context help file may be reassigned.
////			See translateDll.GetHelpFileName()
////		2. Every module tries to open ctxhelp.chm first.
////			If the file does not exist it opens old ctxhelp.hlp.
////		3. If ctx help does not exist, so module tries to use the 
////			predefined html help ( see OnHTMPHelpInfo )
////
//const wchar_t *cDlg::GetContextHelpName()
//{
//	static int len = 0;
//
//	if ( len > 0 )
//		return adHelpFilePath.m_ptr;
//	if ( len < 0 )
//		return NULL;
//
//	wchar_t filePath[ MAX_PATH ] = L"";
//
//#ifdef _UseHtmlHelp_
//#ifndef _NoTranslation_
//	if ( ( pTranslateDll != NULL ) && 
//		 ( pTranslateDll->GetHelpFileName( filePath, maxLen( filePath ) ) ) )
//	{
//		return SetContextHelpName( filePath );
//	}
//#endif // _NoTranslation_
//#endif // _UseHtmlHelp_
//
//	len = GetModuleFileNameT( NULL, filePath, maxLen( filePath ) );
//
//	len = splitPath( filePath, NULL, NULL );
//
//	wcscpy_s( filePath + len, maxLen( filePath ) - len, L"ctxhelp.chm" );
//
//	const wchar_t *path = SetContextHelpName( filePath );
//
//	if ( path == NULL )
//	{
//		wcscpy_s( filePath + len, maxLen( filePath ) - len, L"ctxhelp.hlp" );
//		path = SetContextHelpName( filePath );
//	}
//
//	return path;
//}
//
//const wchar_t *cDlg::SetContextHelpName( const wchar_t *filePath, const wchar_t *fileName )
//{
//	int len;
//
//	isHtmlHelp = false;
//
//	adHelpFilePath.Allocate( MAX_PATH );
//
//	if ( filePath != NULL )
//	{
//		wcscpy_s( adHelpFilePath.m_ptr, adHelpFilePath.m_len, filePath );
//		len = (int)wcslen( adHelpFilePath.m_ptr );
//	}
//	else
//	{
//		if ( fileName == NULL )
//			return NULL;
//
//		len = GetModuleFileNameT( NULL, adHelpFilePath.m_ptr, MAX_PATH );
//		len = splitPath( adHelpFilePath.m_ptr, NULL, NULL );
//
//		wcscpy_s( adHelpFilePath.m_ptr + len, adHelpFilePath.m_len - len, fileName );
//	}
//
//	if ( !FileExistsT( adHelpFilePath.m_ptr ) )
//	{
//		len = -1;
//		return NULL;
//	}
//
//	int pathLen = (int)wcslen( adHelpFilePath.m_ptr );
//
//	isHtmlHelp = ( _wcsicmp( adHelpFilePath.m_ptr + pathLen - 4, L".chm" ) == 0 );
//
//	return adHelpFilePath.m_ptr;
//}
//
#ifdef _UseHtmlHelp_

void cDlg::OnHTMPHelpInfo( HELPINFO* pHelpInfo, DWORD *MenuHelpIDs )
{
	wchar_t path[ 1024 ];
	if ( GetHelpFileName( path, maxLen( path ) ) == NULL )
		return;

	OnHTMPHelpInfo( pHelpInfo, MenuHelpIDs, path, m_useCtxAsIDS );
}

//static 
void cDlg::OnHelpPopup( HELPINFO* pHelpInfo, DWORD *MenuHelpIDs )
{
	DWORD ids;

	if ( !FoundControlId( MenuHelpIDs, pHelpInfo->iCtrlId, &ids ) )
		return;
	
	OnHelpPopup( pHelpInfo, (int)ids );
}

//static 
void cDlg::OnHelpPopup( HELPINFO* pHelpInfo, const wchar_t *str )
{
	OnHelpPopup( (HWND)pHelpInfo->hItemHandle, pHelpInfo->MousePos, str );
}

//static 
void cDlg::OnHelpPopup( HELPINFO* pHelpInfo, int ids )
{
	OnHelpPopup( (HWND)pHelpInfo->hItemHandle, pHelpInfo->MousePos, _LoadIDS( ids ) );
}

// static
void cDlg::OnHelpPopup( HWND hItem, POINT pt, const wchar_t *str )
{
	HH_POPUPW hp;
	memset( &hp, 0, sizeof( hp ) );

	RECT r = { -1,-1,-1,-1  };

	hp.cbStruct = sizeof(hp); //sizeof this structure
	hp.hinst = m_hInst; //instance handle if str res
	hp.idString = 0; // resID; //zero, resource ID, or topic ID
	hp.pszText = (wchar_t*)str; //text to display if idString=0
	hp.pt = pt; // XYPos; // top center of popup 
	hp.clrForeground = COLORREF(-1); //use -1 for default - RGB value
	hp.clrBackground = COLORREF(-1); //use -1 for default - RGB value
	hp.rcMargins = r;//amount of space between edges 
	hp.pszFont = L"MS Shell Dlg, 8,,";//L"MS Sans Serif, 10, , BOLD"; //L"Times New Roman, 8,,";

	HWND hWnd = HtmlHelpT( hItem, NULL, HH_DISPLAY_TEXT_POPUP, (DWORD_PTR)&hp );
}


// static
void cDlg::OnHTMPHelpInfo( HELPINFO* pHelpInfo, DWORD *MenuHelpIDs, const wchar_t *htmlHlpName, bool useCtxAsIDS )
{
	if ( 
		(pHelpInfo->iContextType != HELPINFO_WINDOW) 
//		|| (m_hDlg == pHelpInfo->hItemHandle)
		)
		return;

	DWORD *menuPtr = MenuHelpIDs;

	if ( pHelpInfo->iCtrlId == -1 )
		return;

	DWORD idh;

	if ( !FoundControlId( MenuHelpIDs, pHelpInfo->iCtrlId, &idh ) )
		return;

	if ( !useCtxAsIDS )
	{
		assert( false );

		//wchar_t path[ 1024 ];

		//wcscpy_s( path, htmlHlpName );

		//wcscat_s( path, L"::/ctxhelp.txt" );

		//HWND hWnd = HtmlHelpT( (HWND)pHelpInfo->hItemHandle, path, HH_TP_HELP_CONTEXTMENU, (DWORD_PTR)menuPtr );

		return;
	}

//	MessageBoxT( (HWND)pHelpInfo->hItemHandle, text, L"CTX", MB_OK );

	OnHelpPopup( (HWND)pHelpInfo->hItemHandle, pHelpInfo->MousePos, _LoadIDS( idh ) ); // text );

	//HH_POPUPW hp;
	//memset( &hp, 0, sizeof( hp ) );

	//RECT r = { -1,-1,-1,-1  };

	//hp.cbStruct = sizeof(hp); //sizeof this structure
	//hp.hinst = m_hInst; //instance handle if str res
	//hp.idString = 0; // resID; //zero, resource ID, or topic ID
	//hp.pszText = LoadStringOnceT( idh ); //text to display if idString=0
	//hp.pt = pHelpInfo->MousePos; // XYPos; // top center of popup 
	//hp.clrForeground = COLORREF(-1); //use -1 for default - RGB value
	//hp.clrBackground = COLORREF(-1); //use -1 for default - RGB value
	//hp.rcMargins = r;//amount of space between edges 
	//hp.pszFont = L"MS Shell Dlg, 8,,";//L"MS Sans Serif, 10, , BOLD"; //font

	//HWND hWnd = HtmlHelpT( (HWND)pHelpInfo->hItemHandle, NULL, HH_DISPLAY_TEXT_POPUP , (DWORD_PTR)&hp );
}

#endif // _UseHtmlHelp_

void cDlg::OnHelpInfo( HELPINFO* pHelpInfo, DWORD *MenuHelpIDs, bool showDefault ) 
{
	if ( 
		(pHelpInfo->iContextType != HELPINFO_WINDOW) ||
		(m_hDlg == pHelpInfo->hItemHandle)
		)
		return;

	// Use context help as string in resources...
#ifdef _UseHtmlHelp_
	OnHTMPHelpInfo( pHelpInfo, MenuHelpIDs );
#endif

	return;

//	const wchar_t *ctxHelp = NULL;
//
//#ifdef _UseHtmlHelp_
//
//	if ( !m_useCtxAsIDS )
//		ctxHelp = GetContextHelpName();
//
//#endif
//
//	if ( ctxHelp == NULL )
//	{
//#ifdef _UseHtmlHelp_
//		OnHTMPHelpInfo( pHelpInfo, MenuHelpIDs );
//		return;
//	}
//	else
//	if ( isHtmlHelp )
//	{
//		OnHTMPHelpInfo( pHelpInfo, MenuHelpIDs, ctxHelp );
//#endif
//		return;
//	}
//
//	DWORD *menuPtr = MenuHelpIDs;
//
//	if ( pHelpInfo->iCtrlId == -1 )
//		return;
//
//	if ( !FoundControlId( MenuHelpIDs, pHelpInfo->iCtrlId ) && !showDefault )
//		return;
//
//#pragma warning( disable : 4244 )
//	WinHelpT( (HWND)pHelpInfo->hItemHandle,
//		GetContextHelpName(),
//		HELP_WM_HELP,
//		(WPARAM) menuPtr ); //MenuHelpIDs );
//#pragma warning( default : 4244 )
}

wchar_t *cDlg::GetHelpFileName( wchar_t *path, int wcSize )
{
	int len = GetModuleFileNameT( NULL, path, wcSize );
	wcscpy_s( path + len - 3, wcSize - ( len - 3 ), L"CHM" );

	if ( !FileExistsT( path ) ) // Does not exist
	{
		return NULL;
	}

	return path;
}

bool cDlg::FoundControlId( DWORD *dwPtr, DWORD id, DWORD *pIDH )
{
	for( ; *dwPtr; dwPtr += 2)
		if ( *dwPtr == id )
		{
			if ( pIDH != NULL )
				*pIDH = dwPtr[1];

			return TRUE;
		}

	return FALSE;
}

//
//	_LoadPopupMenu Helper function, it is used for TrackPopup menu
//	By strange reasons it requires really submenu of any menu...
//
HMENU _LoadPopupMenu( HINSTANCE hInst, UINT id, UINT uSubMenu)
{
    HMENU hmParent = LoadMenu( hInst, MAKEINTRESOURCE(id) );

    if (!hmParent)
    {
		return(NULL);
	}

    HMENU hmPopup = GetSubMenu(hmParent, uSubMenu );
    RemoveMenu(hmParent, uSubMenu, MF_BYPOSITION);
    DestroyMenu(hmParent);

#ifndef _NoTranslation_
	if ( pTranslateDll != NULL )
		pTranslateDll->TranslateMenu( hmPopup );
#endif

	return(hmPopup);
}

BOOL Toolbar_SetUnicodeFormat( HWND hToolbar, bool bSet )
{
	BOOL bPrevFormat = SendMessage( hToolbar, CCM_SETUNICODEFORMAT, (WPARAM)bSet, 0 ) != 0;
	return bPrevFormat;
}

DWORD Toolbar_GetStyle( HWND hToolbar )
{	return (DWORD)SendMessage( hToolbar, (UINT) TB_GETSTYLE,  0,0 ); }

void Toolbar_SetStyle( HWND hToolbar, DWORD dwStyle )
{	SendMessage( hToolbar, (UINT) TB_SETSTYLE,  0, (LPARAM)dwStyle ); }

BOOL ToolBar_EnableButton( HWND hToolbar, int id, BOOL enable )
{	return (BOOL)SendMessage( hToolbar, TB_ENABLEBUTTON, (WPARAM)id, (LPARAM)(MAKELONG(enable, 0)) );}

BOOL ToolBar_CheckButton( HWND hToolbar, int id, BOOL check )
{	return (BOOL)SendMessage( hToolbar, TB_CHECKBUTTON, (WPARAM)id, (LPARAM)(MAKELONG(check, 0)) );}

int ToolBar_AddButton( HWND hToolbar, int iBmp, int iCmd, int style/* = 0*/, int state /* = TBSTATE_ENABLED */ )
{
	TBBUTTON tbb[1];
	memset( &tbb[0], 0, sizeof( TBBUTTON ) );

	tbb[0].iBitmap = iBmp; 
	tbb[0].idCommand = iCmd; 
	tbb[0].fsState = (BYTE)state;
	tbb[0].fsStyle = TBSTYLE_BUTTON | style | TBSTYLE_TRANSPARENT | TBSTYLE_TOOLTIPS; 
	tbb[0].dwData = 0; 
	tbb[0].iString = NULL;

	return (int)SendMessage( hToolbar, TB_ADDBUTTONS, 1, (LPARAM) (LPTBBUTTON) &tbb);
}

HIMAGELIST Toolbar_GetImageList( HWND hToolbar  )
{
	return ( HIMAGELIST )SendMessage( hToolbar, TB_GETIMAGELIST, 0, 0 );
}


#ifndef BTNS_SEP
#define BTNS_SEP TBSTYLE_SEP
#endif

int ToolBar_AddSep( HWND hToolbar  )
{
	TBBUTTON tbb[1];
	memset( &tbb[0], 0, sizeof( TBBUTTON ) );
	tbb[0].fsStyle = BTNS_SEP; 

	return (int)SendMessage( hToolbar, TB_ADDBUTTONS, 1, (LPARAM) (LPTBBUTTON) &tbb);
}

DWORD LV_getStyle( HWND hList )
{
	DWORD dwlStyle = GetWindowLong( hList, GWL_STYLE);
	DWORD style = dwlStyle & LVS_TYPEMASK;
	return  style;
}

void LV_setStyle( HWND hList, DWORD style )
{
	DWORD dwStyle = GetWindowLong( hList, GWL_STYLE);
	dwStyle &= ~LVS_TYPEMASK;
	style = style & LVS_TYPEMASK;

	dwStyle |= style;

	SetWindowLong( hList, GWL_STYLE, dwStyle );
}

///////////
//
//	cMBTextDlg 
//
BOOL CALLBACK cMBTextDlg::addButton( HWND hWnd, LPARAM lParam )
{
	cMBTextDlg *dlg = (cMBTextDlg *)lParam;
	if ( dlg == NULL )
		return true;

    char szClass[16];
	if ( !::GetClassNameA( hWnd, szClass, sizeof( szClass ) ) )
		return true;
			
	if ( _stricmp( szClass, "button" ) == 0  )
	{
		int id = GetDlgCtrlID( hWnd );
		if ( id == 0 )
			return true;
		cSizedCtrls::ePosType positionType;

		if ( id == dlg->m_idcChk )
			positionType = cSizedCtrls::ptPDSR;
		else
			positionType = cSizedCtrls::ptPDR; // (cSizedCtrls::ePosType)(cSizedCtrls::ptPD | cSizedCtrls::ptPHC);

		dlg->m_sizedCtrls.AddCtrl( hWnd, positionType );

		if ( dlg->m_timeoutButtonId == id )
		{
			dlg->m_hTimeoutButton = hWnd;
		}
		else
		if ( dlg->m_timeoutButton >= 0 )
		{
			if ( --(dlg->m_timeoutButton) == 0 )
				dlg->m_hTimeoutButton = hWnd;
		}
	}
	
	return true;
}

static const UINT_PTR timoutButtonID = 0xBCD;

//static 
VOID CALLBACK cMBTextDlg::static_timeoutProc( HWND hDlg, UINT uMsg, UINT_PTR idEvent, DWORD dwTime )
{
	cMBTextDlg *pThis = (cMBTextDlg *)GetDlgClass(hDlg);

	if ( pThis == NULL )
		return;

	pThis->timeoutProc( uMsg, idEvent, dwTime );
}

UINT_PTR cMBTextDlg::timeoutProc( UINT uMsg, UINT_PTR idEvent, DWORD dwTime )
{
	if ( m_hTimeoutButton == NULL )
		return 0;

	if ( --m_timeoutCountdown <= 0 )
	{
		int id = GetDlgCtrlID( m_hTimeoutButton );

		if ( id != 0 )
			PostMessage( m_hDlg, WM_COMMAND, id, 0 );

		return 0;
	}

	cWCStr wcs;
	wcs.FormatT( L"%s (%d)", m_wcsTimeoutButtonText.m_szBody, m_timeoutCountdown );
	SetWindowTextT( m_hTimeoutButton, wcs.m_szBody );
	ShowWindow( m_hTimeoutButton, SW_SHOW );

	m_timerEvent = SetTimer( m_hDlg, timoutButtonID, 1000, static_timeoutProc );

	return m_timerEvent;
}

static void MoveWindowToCenterOf( HWND hWnd, cRect &p )
{
	cRect r;
	GetWindowRect( hWnd, &r );

	int x = p.left + p.Width()/2 - r.Width()/2;
	int y = p.top + p.Height()/2 - r.Height()/2;

	int delta = 10;

	SetWindowPos( hWnd, HWND_TOP, x + delta, y + delta, 0, 0, SWP_NOSIZE );
}

LRESULT cMBTextDlg::RealDlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	if ( uMsg == WM_INITDIALOG )
	{
		//ODSFunc;

		if ( m_dlgBoldText != NULL )
		{
			HWND hBoldText = GetDlgItem( m_hDlg, m_idcBold );
			SetWindowTextT( hBoldText, m_dlgBoldText );
		}

		for( int i = 0; i < m_itemTextT.m_Q; i++ )
		{
			HWND hText = GetDlgItem( m_hDlg, m_itemTextT.m_T[i].m_idc );
			SetWindowTextT( hText, m_itemTextT.m_T[i].m_text );
		}

		SetWindowTextT( m_hDlg, m_caption );
		UpdateDlgItemTextT( m_hDlg, m_idcSizedText, m_dlgText );
		m_sizedCtrls.Init( m_hDlg );

		m_sizedCtrls.AddCtrl( m_idcSizedText,	cSizedCtrls::ptSDR );
		if ( m_idcLine != 0 )
			m_sizedCtrls.AddCtrl( m_idcLine, cSizedCtrls::ptPDSR );

		EnumChildWindows( m_hDlg, addButton, (LPARAM)this );

		HWND hText = GetDlgItem( m_hDlg, m_idcSizedText );
		
		if ( m_parentRect.top >= 0 )
			MoveWindowToCenterOf( m_hDlg, m_parentRect );
		else
		if ( m_pos.x < 0 ) // == -1
			MoveWindowToCursorPosition();
		else
			SetWindowPos( m_hDlg, HWND_TOP, m_pos.x, m_pos.y, 0, 0, SWP_NOSIZE );

		ResizeByText( hText, SWP_NOMOVE );
		MapToScreen();

		if ( m_idcChk != 0 )
		{
			HWND hWnd = GetDlgItem( m_hDlg, m_idcChk );
			Button_SetCheck( hWnd, m_bChk ? BST_CHECKED : BST_UNCHECKED );
			if ( m_chkText != NULL )
				SetWindowTextT( hWnd, m_chkText );

			RECT r;
			cDlg::GetDlgItemRect( m_hDlg, hWnd, &r );
			m_lineRect.top = r.bottom + 7;
		}
		else
		{
			HWND hLine = GetDlgItem( m_hDlg, m_idcLine );
			if ( hLine != NULL )
				cDlg::GetDlgItemRect( m_hDlg, hLine, &m_lineRect );
		}

		if ( m_hTimeoutButton )
		{
			m_wcsTimeoutButtonText.GetWindowTextT( m_hTimeoutButton );
			timeoutProc( 0, 0, 0 );
		}

		if ( ( m_iStd != 0 ) && ( m_idcIcon != 0 ) )
		{
			m_hIcon = LoadIcon( NULL, m_iStd );

			HWND hWnd = GetDlgItem( m_hDlg, m_idcIcon );

			if ( hWnd != NULL )
			{
				RECT rIcon;
				cDlg::GetDlgItemRect( m_hDlg, hWnd, &rIcon );

				 // Makes minimal distance beatween line and icon same as from dlg top to the icon.
				int dy =  rIcon.bottom + rIcon.top - m_lineRect.top;

				if ( dy > 0 )
				{
					cRect r;
					GetWindowRect( m_hDlg, &r );
					SetWindowPos( m_hDlg, HWND_TOP, r.left, r.top, r.Width(), r.Height() + dy, SWP_NOMOVE );

					HWND hLine = GetDlgItem( m_hDlg, m_idcLine );
					if ( hLine != NULL )
						cDlg::GetDlgItemRect( m_hDlg, hLine, &m_lineRect );
				}

			}
		}

	}
	else
	if ( uMsg == WM_SIZE )
	{
		m_sizedCtrls.OnSize( lParam );
	}
	else
	if ( uMsg == WM_COMMAND )
	{
		int cmd = LOWORD(wParam);

		if ( m_disableCancel && ( cmd == IDCANCEL ) )
			return 0;

		if ( cmd != m_idcChk )
		{
			if ( m_idcChk != 0 )
				m_bChk = Button_GetCheck( GetDlgItem( m_hDlg, m_idcChk ) ) == BST_CHECKED;

			if ( m_timerEvent != 0 )
				KillTimer( m_hDlg, m_timerEvent );

			EndDialog( m_hDlg, cmd );
		}
	}
	else
	if ( uMsg == WM_DESTROY )
	{
		RECT r;
		GetWindowRect( m_hDlg, &r );
		m_pos.x = r.left;
		m_pos.y = r.top;
	}
	else
	if ( uMsg == WM_PAINT )
	{
		if ( m_hIcon != NULL )
		{
			HDC dc;
			PAINTSTRUCT ps;

			if ((HDC) wParam != NULL)
				dc = (HDC) wParam;
			else
				dc = BeginPaint( m_hDlg, &ps );

			DrawFileIcon( m_hDlg, dc, m_hIcon, m_idcIcon );

			if ((HDC) wParam == NULL)
				EndPaint( m_hDlg, &ps );
		}
	}

	return FALSE;
}

void cDlgBase::UpdateCaption()
{
	if ( m_idcInfo == 0 )
		return;
	
	if ( m_wcsCaption.isEmpty() )
		m_wcsCaption.GetWindowTextT( m_hDlg );

	cWCStr wcs;

	if ( IsIconic( m_hDlg ) )
	{
		if ( wcs.GetWindowTextT( GetItem( m_idcInfo ) ) != 0 )
			wcs.Add( L", " );
	}

	wcs.Add( m_wcsCaption );

	SetWindowTextT( m_hDlg, wcs.m_szBody );
}

////static 
//DWORD WINAPI cDelayVisible::threadFunc( LPVOID lpThreadParameter )
//{
//	cDlg *pThis = (cDlg *)lpThreadParameter;
//	if ( pThis == NULL )
//	{
//		assert( false );
//		return -1;
//	}
//
//	HWND hWnd = pThis->m_hDlg;
//
//	Sleep( pThis->m_delayVisible.m_iTimeout );
//
//	if ( IsWindow( hWnd ) )
//		ShowWindow( hWnd, SW_SHOW );
//
//	return 0;
//}


void cTheme::UpdateBackgroundBrush( HWND hDlg )
{
	if ( !cComCtl32Dll::getStatic().LoadOnce() )
		return;

	if ( cComCtl32Dll::getStatic().version.dwMajorVersion < 6 )
		return;

	if ( m_hBrush != NULL )
		return;

    HMODULE hinstDll = 0;

    // Check if the application is themed
	static CDll utDll( false, L"UxTheme.dll", "IsAppThemed", false );
	if ( !utDll.error )
	{
        typedef BOOL (*ISAPPTHEMEDPROC)();
        ISAPPTHEMEDPROC pIsAppThemed;
		pIsAppThemed = (ISAPPTHEMEDPROC)utDll.pProc;

        if(pIsAppThemed)
            m_bThemeActive = ( pIsAppThemed() == TRUE );
	}

    //hinstDll = ::LoadLibraryA( "UxTheme.dll" );
    //if (hinstDll)
    //{
    //    typedef BOOL (*ISAPPTHEMEDPROC)();
    //    ISAPPTHEMEDPROC pIsAppThemed;
    //    pIsAppThemed = 
    //      (ISAPPTHEMEDPROC) ::GetProcAddress(hinstDll, "IsAppThemed");

    //    if(pIsAppThemed)
    //        m_bThemeActive = ( pIsAppThemed() == TRUE );

    //    ::FreeLibrary(hinstDll);
    //}

    // Destroy old brush
    if ( m_hBrush != NULL )
        ::DeleteObject( m_hBrush );

    m_hBrush = NULL;

    // Only do this if the theme is active
    if (m_bThemeActive)
    {
        RECT rc;

		HWND hTab = GetParent( hDlg );

        // Get tab control dimensions
        GetWindowRect( hTab, &rc );

        // Get the tab control DC
        HDC hDC = GetDC( hTab );

        // Create a compatible DC
        HDC hDCMem = ::CreateCompatibleDC(hDC);
        HBITMAP hBmp = ::CreateCompatibleBitmap(hDC, rc.right - rc.left, rc.bottom - rc.top );
        HBITMAP hBmpOld = (HBITMAP)(::SelectObject(hDCMem, hBmp));

        // Tell the tab control to paint in our DC
        SendMessage( hTab, WM_PRINTCLIENT, (WPARAM)(hDCMem), (LPARAM)(PRF_ERASEBKGND | PRF_CLIENT | PRF_NONCLIENT));

        // Create a pattern brush from the bitmap selected in our DC
        m_hBrush = ::CreatePatternBrush( hBmp );

        // Restore the bitmap
        ::SelectObject( hDCMem, hBmpOld );

        // Cleanup
        ::DeleteObject( hBmp );
        ::DeleteDC( hDCMem );
        ReleaseDC( hTab, hDC );
    }
}

LRESULT cTheme::OnCtlColor( HWND hDlg, WPARAM wParam, LPARAM lParam ) // , BOOL *bHandled )
{
	//// Set the background mode to transparent
	//::SetBkMode((HDC)(wParam), TRANSPARENT);

	//// Return the brush return 
	//return (LRESULT)(::GetStockObject(HOLLOW_BRUSH));

    if (m_bThemeActive)
    {
        RECT rc;

        // Set the background mode to transparent
        ::SetBkMode((HDC)(wParam), TRANSPARENT);

        // Get the controls window dimensions
        ::GetWindowRect((HWND)(lParam), &rc);

        // Map the coordinates to coordinates with the upper
        // left corner of dialog control as base

		HWND hTab = GetParent( hDlg );

        ::MapWindowPoints(NULL, hTab, (LPPOINT)(&rc), 2);

        // Adjust the position of the brush for this control
        // (else we see the top left of the brush as background)
/////		rc.top += 100;

        ::SetBrushOrgEx((HDC)(wParam), -rc.left, -rc.top, NULL);

        // Return the brush
        return (LRESULT)(m_hBrush);
    }

    return FALSE;
}

bool cTheme::DlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT &lRes )
{
	switch( uMsg )
	{
		case WM_ERASEBKGND:
			UpdateBackgroundBrush( hDlg );
            lRes = m_bThemeActive;
			return true;
 // Otherwise it uses page background brush for list box popupped when combobox is opened. Edit control copies main window background too.
 // Undefifened here controls looks not as native themed but theires background is ok.
#ifdef _IgnoreInvalidView
		case WM_CTLCOLOREDIT:
		case WM_CTLCOLORLISTBOX:
//#else
//		case WM_CTLCOLOREDIT:
//		case WM_CTLCOLORLISTBOX:
//			if ( !m_bThemeActive )
//				lRes == NULL;
//			else
//			{
//				SetBkMode((HDC)(wParam), TRANSPARENT);
//				lRes = (LRESULT)(GetStockObject(WHITE_BRUSH));
//			}
//			return true;
#endif
		case WM_CTLCOLORBTN:
		case WM_CTLCOLORDLG:
		case WM_CTLCOLORSCROLLBAR:
		case WM_CTLCOLORSTATIC:
			lRes = OnCtlColor( hDlg, wParam, lParam  );
			return true;

		case WM_DESTROY:

			if ( m_hBrush != NULL )
				DeleteObject( m_hBrush );

			return false;

		default:
			return false;
	}
}

bool GetDispInfo( HINSTANCE hInst, LPNMTTDISPINFOA lpnmtdi, int ids )
{
	// stores the info
	lpnmtdi->uFlags = TTF_DI_SETITEM; // 0;

	lpnmtdi->szText[0] = '\0';

#ifndef _NoTranslation_
	if ( pTranslateDll != NULL )
	{
		if ( pTranslateDll->m_flipDialog )
			lpnmtdi->uFlags |= TTF_RTLREADING;

		lpnmtdi->hinst = NULL;
		LoadStringTA( hInst, ids, lpnmtdi->szText, 80 );

		// Use Toolbar_SetUnicodeFormat to get unicode display info with TTN_GETDISPINFOW instead of TTN_GETDISPINFOA 
		if ( lpnmtdi->szText[0] == '\0' )
			ODS_fls( _FormatT( L"Resource string '%s' was not translated to ANSI", _LoadIDS(ids) ) );
	}
#endif // _NoTranslation_

	//
	//	13.04.2017 It is nonsense to translate to Russian, Farsi ...
	//		This check allows to use not translated texts
	//
	if ( lpnmtdi->szText[0] == '\0' )
	{
		lpnmtdi->hinst = hInst;
		lpnmtdi->lpszText = MAKEINTRESOURCEA( ids );
	}

	return true;
}

bool GetDispInfo( HINSTANCE hInst, LPNMTTDISPINFOW lpnmtdiW, int ids )
{
	// stores the info
	lpnmtdiW->uFlags = TTF_DI_SETITEM; //0;

#ifndef _NoTranslation_
	if ( pTranslateDll != NULL )
	{
		if ( pTranslateDll->m_flipDialog )
			lpnmtdiW->uFlags |= TTF_RTLREADING;

		lpnmtdiW->hinst = NULL;
		LoadStringT( hInst, ids, lpnmtdiW->szText, 80 );
	}
	else
#endif // _NoTranslation_
	{
		lpnmtdiW->hinst = hInst;
		lpnmtdiW->lpszText = MAKEINTRESOURCEW( ids );
	}

	return TRUE;
}