#pragma once

#include "cDlgProgressMT.h"
#include "cRandomGen.h"

class cDlgCreateFile : public cDlgProgressMT
{
public:
	HANDLE m_hFile;
	DWORDLONG m_length;

	cRandomGenMT m_rngObj;

	cWCStr m_flushText;

	static DWORD static_SetLengthThreadProc( cDlgCreateFile *pThis );
	DWORD setLengthThreadProc();
	bool setFileLength( DWORDLONG length, int *pErrorNumber );

	cDlgCreateFile(
			HANDLE hFile,
			DWORDLONG length,
			int idsTerminateQ,				// IDS for MessageBox question if Cancell button was pressed.
			const wchar_t *caption = NULL,	// If is NULL it does not change original dlg resource text.
			const wchar_t *text	= NULL,		// -||-
			const wchar_t *flushText = NULL,// -||-
			int randomBufferSize = 0,		// If not zero created file is filled by random data.
			int *idcT = NULL )

				: cDlgProgressMT( (typeThreadProc *)static_SetLengthThreadProc, idsTerminateQ, caption, text, idcT )
	{
		m_hFile = hFile;
		m_length = length;
		m_rngObj.Init( randomBufferSize );
		m_flushText.Add( flushText );
	}
};
