#pragma once

//
//	Tabulated view dialog
//
//	1. Every string at tabbedText is inserted as new string to idcVew control.
//	2. Every part at the string is separated by '\t' and is inserted to corresponded column to the idcVew control.
//	3. First string at tabbedText is '\t' separated column names.
//

#include "cDlg.h"
#include "ptbRegs.h"

class cDlgTabView : public cDlgBase
{
protected:
	const wchar_t *m_tabbedText;
	int m_idcView;
	int m_idiIcon;
	const wchar_t *m_caption;
	int m_iColumns;

public:
	cRegDlgValues m_rv;

	cDlgTabView( int idcView, const wchar_t *tabbedText, const wchar_t *caption = NULL, int idiIcon = 0 )
	{
		m_idcView = idcView;
		m_idiIcon = idiIcon;
		m_tabbedText = tabbedText;
		m_caption = caption;
		m_iColumns = 0;
	}

	virtual bool OnCommand( WPARAM wParam, LPARAM lParam )
	{
		m_rv.Save( m_hDlg, GetItem( m_idcView ) );
		EndDialog( m_hDlg, wParam );
		return true;
	}

	virtual bool InitDialog();
};