/*
 *	Copyright 2014 Jetico, Inc. All rights reserved.
 *
 *	File: cGetDlgCodeCtrl.h
 *
 *	Class cGetDlgCodeCtrl declaration.
 *
 *	Description:
 *		By deafult control at dialog does not get VK_RETURN and VK_ESCAPE.
 *		Dialog gets IDOK or IDCANCEL instead.
 *		This class allows to catch VK_RETURN and VK_ESCAPE with WM_KEYDOWN message for correponded control.
 *
 *	Created:	29.05.2013
 *	Author:		Alexander Pichuev.
 */

#pragma once

#include "cWndProcInterceptor.h"

class cGetDlgCodeCtrl : public cWndProcInterceptor
{
	DWORD m_dwDlgCode;

public:

	virtual bool wndProc( LRESULT *pResult, UINT uMsg, WPARAM wParam, LPARAM lParam )
	{
		if ( uMsg != WM_GETDLGCODE )
			return false;
	
		*pResult = (LRESULT)m_dwDlgCode;

		return true;
	}

	cGetDlgCodeCtrl( HWND hCtrl = NULL, DWORD dwDlgCode = DLGC_WANTALLKEYS )
	{
		m_dwDlgCode = dwDlgCode;

		if ( hCtrl != NULL )
			Set( hCtrl, dwDlgCode );
	}	

	void Set( HWND hCtrl, DWORD dwDlgCode = DLGC_WANTALLKEYS )
	{
		m_dwDlgCode = dwDlgCode;
		// ??? It was -> cWndProcInterceptor::Set( hCtrl );
		this->m_hCtrl = hCtrl;
	}
};
