#pragma once

//
//	cMenuIconDll
//		Uses Windows Vista specific functions for adding alpha blending icon to menu.
//

#include "cDll.h"

class cMenuIconDll : public CDll
{
	typedef HRESULT typeAddIconToMenuItem(HMENU hmenu, int iMenuItem, BOOL fByPosition, HICON hicon, BOOL fAutoDestroy, __out_opt HBITMAP *phbmp );
	typeAddIconToMenuItem *m_procAddIconToMenuItem;
	typedef LONG typeLoadIconMetricT( HINSTANCE hInst, LPWSTR iconId, int type, HICON *phIcon  );
	typeLoadIconMetricT *m_procLoadIconMetricT;

public:
	cMenuIconDll()
	{
		Load( false, L"menuIcon.dll", NULL, false );
		GetProcAddress( "AddIconToMenuItem", false, (void**)&m_procAddIconToMenuItem );
		GetProcAddress( "LoadIconMetricT", false, (void**)&m_procLoadIconMetricT );
	}

	HRESULT AddIconToMenuItem(HMENU hMenu, int iMenuItem, BOOL fByPosition, HICON hicon, BOOL fAutoDestroy = false, HBITMAP *phbmp = NULL )
	{
		if ( m_procAddIconToMenuItem == NULL )
			return (HRESULT)-1;

		return m_procAddIconToMenuItem( hMenu, iMenuItem, fByPosition, hicon, fAutoDestroy, phbmp );
	}

	LONG LoadIconMetric( HINSTANCE hInst, LPWSTR iconId, int type, HICON *phIcon  )
	{
		if ( m_procLoadIconMetricT == NULL )
			return (LONG)-1;

		return m_procLoadIconMetricT( hInst, iconId, type, phIcon );
	}
};
