#ifndef __cSplitter__
#define __cSplitter__

#include <windows.h>
#include <assert.h>
#include <tchar.h>

#ifndef GWLP_USERDATA
#define GWLP_USERDATA GWL_USERDATA
#define SetWindowLongPtr SetWindowLong
#define GetWindowLongPtr GetWindowLong
#endif

class cSplitter
{
	static bool m_isRegisterred;
	static const wchar_t *m_szClassName;

	HKEY m_hRegRoot;
	wchar_t *m_regKeyName;

	bool m_draged;

	HWND m_hRightBottom;
	HWND m_hLeftTop;

	bool m_bVertical;

	//
	//	The size of splitter may be limited by m_sizeMax
	//	the m_dx and m_dy is the distances from splitter to rigth/down pane. 
	//
	int m_sizeMax;
	int m_dx;
	int m_dy;

	//
	//	The windows may be placed at the splitter region and have be moved with splitter.
	//
	HWND *m_nestedT;
	int m_nestedQ;

public:
	HWND m_hParent;

	HINSTANCE m_hInst;
	RECT m_rect, m_rSave;
	WORD m_posX;
	WORD m_posY;

	HWND m_hWnd;

	bool m_flip;

	cSplitter( HINSTANCE hInst, HKEY hRegRoot = HKEY_CURRENT_USER, const wchar_t *regKeyName = NULL )
	{
		m_hInst = hInst;
		RegisterClass( m_hInst );

		m_hRegRoot = hRegRoot;

		if ( regKeyName == NULL )
			m_regKeyName = NULL;
		else
		{
			int len = (int)wcslen( regKeyName ) + 1;
			m_regKeyName = new wchar_t[ len ];
			if ( m_regKeyName != NULL )
				wcscpy_s( m_regKeyName, len, regKeyName );
		}

		m_bVertical = false;
		m_sizeMax = 5;
		m_dx = 0;
		m_dy = 0;

		m_nestedT = NULL;
		m_nestedQ = 0;
	}

	~cSplitter()
	{
		Close();
		if ( m_regKeyName != NULL )
			delete m_regKeyName;

		if ( m_nestedT != NULL )
			delete [] m_nestedT;
	}

	static bool RegisterClass( HINSTANCE hInst );
	static LRESULT CALLBACK staticWndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );

	LRESULT CALLBACK RealWndProc( UINT uMsg, WPARAM wParam, LPARAM lParam );

	void OnMouseMove( DWORD vKeys, short x, short y );
	void OnLButtonDown( DWORD vKeys, short x, short y );
	void OnLButtonUp( DWORD vKeys, short x, short y );
	void Init( HWND hParent, HWND hLeftTop, HWND pRightBottom, HWND *nestedT = NULL, int nestedQ = 0 );
	void Close();
	RECT GetRect( HWND hWnd = NULL );

	bool saveWindowPos( RECT *r );
	bool getWindowPos( RECT *r );
	void moveClients( RECT *rs );
};


#endif // __cSplitter__