#pragma once

#include "cWCS.h"
#include "FormatT.h"

#define _FormatT cWCSF().FormatT

class cWCSF : public cWCS
{
public:

	cWCSF( cWCS &wcs, bool bSwap = false )				: cWCS( wcs, bSwap ){}
	cWCSF( const wchar_t *wcs = NULL, int len = -1 )	: cWCS( wcs, len )	{}
	cWCSF( int len )									: cWCS( len )		{}

	static const int maxFormatLength = 4090; // 4096;

	const wchar_t *AddF( const wchar_t *pattern, ... )
	{
		cWCS wcs( maxFormatLength );

		if ( wcs.m_szBody == NULL )
			return L"<NULL>";

		cVAList vl;
		va_start( vl.marker, pattern );

		::FormatT( wcs.m_szBody, wcs.m_len, &vl, pattern );

		Add( wcs.m_szBody );

		return m_szBody;
	}

	const wchar_t *FormatT( const wchar_t *pattern, ... )
	{
		if ( SetLength( maxFormatLength ) == 0 )
			return L"<NULL>";

		cVAList vl;
		va_start( vl.marker, pattern );

		::FormatT( m_szBody, m_allocatedLen, &vl, pattern );

		Truncate();

		return m_szBody;
	}

	const wchar_t *SetIPAddress( DWORD dwIPAddress )
	{
		return FormatT( L"%d.%d.%d.%d", (0xFF&(dwIPAddress >> 8 * 3)), (0xFF&(dwIPAddress >> 8 * 2)),(0xFF&(dwIPAddress >> 8 * 1)),(0xFF & dwIPAddress) );
	}
};
