/*++

Copyright (c) 2018 Jetico, Inc.

Module Name:
    WaitForMultipleObjects.h

Abstract:
	Helper class for waiting multiply objects.

Created:
	02.10.2018

Author:
	A. Pichuev

--*/

#pragma once

#include "AutoDeallocate.h"

class cWaitForMultipleObjects : public cADBlock < HANDLE >
{
public:

	bool m_bWaitAll;
	DWORD m_tiemout;
	bool m_deleteAfterWaiting;
	
	cWaitForMultipleObjects( bool bWaitAll = true, DWORD timeout = INFINITE, bool deleteAfterWaiting = true )
		: cADBlock( 0, true )
	{
		m_bWaitAll = bWaitAll;
		m_tiemout = timeout;
		m_deleteAfterWaiting = deleteAfterWaiting;
	}

	virtual ~cWaitForMultipleObjects()
	{
	}

	DWORD waitObjects()
	{
		DWORD dwRes = WaitForMultipleObjects( m_Q, m_T, m_bWaitAll, m_tiemout );

		return dwRes;
	}

	virtual int waitActor( DWORD dwWaitResult ) { return 0; }

	static DWORD WINAPI static_waitThread( void *param )
	{
		cWaitForMultipleObjects *pThis = (cWaitForMultipleObjects *)param;

		if ( pThis == NULL )
		{ ODS_fls( L"Assertion!" ); return -1; }

		while( true )
		{
			DWORD dwWaitResult = pThis->waitObjects();

			if ( pThis->waitActor( dwWaitResult ) == 0 )
			{
				if ( pThis->m_deleteAfterWaiting )
					delete pThis;

				return dwWaitResult;
			}
		}
	}	
};
