#pragma once

#include <windows.h>
#include <assert.h>
#include "..\Includes\UnicodeFuncs.h"
#include "..\Includes\TranslateDll.h"

const HWND hwndSig = (HWND)0x00AA55FF;

class cWnd
{
public:
	static cWnd *cWnd::GetClass( HWND hWnd )
	{
		cWnd *wnd = (cWnd *)(LONG_PTR)GetWindowLongPtr( hWnd, GWLP_USERDATA );

		if ( ( wnd != NULL ) && ( wnd->m_hWnd != hWnd ) )
		{
			assert( false );
		}

		return wnd;
	}

	static void cWnd::SetClass( HWND hWnd, cWnd *wnd )
	{
		wnd->m_hWnd = hWnd;
#pragma warning( disable : 4244 )
		SetWindowLongPtr( hWnd, GWLP_USERDATA, (LONG_PTR)wnd );
#pragma warning( default : 4244 )

		assert( GetClass( hWnd ) == wnd );
	}

	HWND m_hWnd;

	cWnd()
	{
		m_hWnd = hwndSig;
	}

	bool CreateEx(
		DWORD dwExStyle,
		LPCWSTR lpClassName,
		LPCWSTR lpWindowName,
		DWORD dwStyle,
		int x, int y, int nWidth, int nHeight,
		HWND hWndParent,
		HMENU hMenu,
		HINSTANCE hInstance )
	{

		return  NULL != CreateWindowExT( dwExStyle, lpClassName, lpWindowName, dwStyle, x, y, nWidth, nHeight, hWndParent, hMenu, hInstance, this );
	}


	static BOOL RegisterWndClass( HINSTANCE hInst, const wchar_t *className, HICON hIcon = NULL, HCURSOR hCursor = NULL )  
	{ 
		WNDCLASSW wc;
		memset( &wc, 0, sizeof( wc ) );
	 
		wc.style         = 0; 
		wc.lpfnWndProc   = (WNDPROC)cWnd::DefWndProc;
		wc.cbClsExtra    = 0; 
		wc.cbWndExtra    = 0; 
		wc.hInstance     = hInst; 
		wc.hIcon         = hIcon; // LoadIcon(hInst,MAKEINTRESOURCE(IDR_MAINFRAME)); 
		wc.hCursor       = hCursor; //LoadCursor((HANDLE) NULL, IDC_ARROW); 
		wc.hbrBackground = 0; //(HBRUSH) (COLOR_APPWORKSPACE + 1); 
		wc.lpszMenuName  = 0; //IDMULTIPAD; 
		wc.lpszClassName = className; 
	 
		if (!RegisterClassT (&wc) ) 
			return FALSE; 
	 
		return TRUE; 
	}

	static LRESULT APIENTRY DefWndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam) 
	{
		cWnd *pThis = GetClass( hWnd );

		if ( uMsg == WM_CREATE )
		{
			//if ( DefWindowProcT( hWnd, WM_CREATE, wParam, lParam ) == -1 )
			//{
			//	assert( false );
			//	return -1;
			//}

			CREATESTRUCT *cs = (CREATESTRUCT *)lParam;
			if ( cs == NULL )
			{
				assert( false );
				return -1;
			}

			pThis = (cWnd *)(cs->lpCreateParams);

			if ( pThis->m_hWnd != hwndSig )
			{
				assert( false );
				return -1;
			}

			SetClass( hWnd, pThis );

			if ( pTranslateDll != NULL )
				pTranslateDll->TranslateDialog( hWnd );

		}
		else if ( uMsg == WM_GETMINMAXINFO )
		{
			MINMAXINFO *p = (MINMAXINFO *)lParam;

			//if ( pThis->m_trackingFixType != ttfNone )
			//{
			//	if ( pThis->m_trackingFixType & ttfMinX )
			//		p->ptMinTrackSize.x = pThis->m_minSize.x;
			//	if ( pThis->m_trackingFixType & ttfMinY )
			//		p->ptMinTrackSize.y = pThis->m_minSize.y;

			//	if ( pThis->m_trackingFixType & ttfMaxX )
			//		p->ptMaxTrackSize.x = pThis->m_maxSize.x;
			//	if ( pThis->m_trackingFixType & ttfMaxY )
			//		p->ptMaxTrackSize.y = pThis->m_maxSize.y;

			//	return 0;
			//}
		}

		if ( pThis == NULL )
		{
		//	assert( false );
			return DefWindowProcT( hWnd, uMsg, wParam, lParam );
		}

		return pThis->RealWndProc( uMsg, wParam, lParam );
	}

	virtual LRESULT RealWndProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
	{
		assert( false );
		return DefWindowProcT( m_hWnd, uMsg, wParam, lParam );
	}

	static void MoveWindow( HWND hWnd, RECT *r, bool pRepaint = true )
	{
		::MoveWindow( hWnd, r->left, r->top, r->right - r->left, r->bottom - r->top, pRepaint );
	}

	static void ScreenToClient( HWND hWnd, RECT *r )
	{
		::ScreenToClient( hWnd, (POINT*)&(r->left) );
		::ScreenToClient( hWnd, (POINT*)&(r->right) );
	}
};
