#include "filterUnload.h"
#include "ODS.h"
#include "cWCSF.h"

static const wchar_t *szFltmc = L"fltmc.exe";

static int getFltMCPath( cWCSF &wcs )
{
	wcs.SetLength( MAX_PATH );

	if ( GetSystemDirectory( wcs.m_szBody, wcs.m_allocatedLen ) == 0 )
	{
		int res = GetLastError();
		ODS_fls( _FormatT( L"Assertion! Error %d in getting system directory", res ) );
		return res;
	}

	wcs.Truncate();
	wcs.AddF( L"\\%s", szFltmc );

	if ( _waccess( wcs.m_szBody, 0 ) != 0 )
	{
		ODS_fls( _FormatT( L"Assertion! The system cannot find file '%s'", wcs.m_szBody ) );
		return ERROR_FILE_NOT_FOUND;
	}

	return NO_ERROR;
}

static HRESULT RunProcess( wchar_t *cmd )
{
	HRESULT res = S_OK;
	STARTUPINFOW stInfo;
	memset(&stInfo,0,sizeof(stInfo));
	stInfo.cb = sizeof(stInfo);

	stInfo.dwFlags = STARTF_USESHOWWINDOW;
	stInfo.wShowWindow = SW_HIDE;

	PROCESS_INFORMATION prInfo;

	memset( &prInfo, 0, sizeof( prInfo ) );

	BOOL ok = CreateProcess( NULL, cmd, NULL, NULL, false, CREATE_SHARED_WOW_VDM, NULL, NULL, &stInfo, &prInfo );

	if ( ok )
	{
		res = S_OK;
		CloseHandle( prInfo.hProcess );
		CloseHandle( prInfo.hThread );
	}
	else
	{
		res = GetLastError();
		ODS_fls( _FormatT( L"Assertion! Error %d in loading module '%s'", res, cmd ) );
	}

	return res;
}

HRESULT _FilterUnload( const wchar_t *filterName )
{
	// Unfortunately fltMC.exe has not signature!!
	// We just start the executable from system directory.

	cWCSF wcs;

	int res = getFltMCPath( wcs );

	if ( res != NO_ERROR )
		return res;

	wcs.AddF( L" unload %s", filterName );

	return RunProcess( wcs.m_szBody );
}