#pragma once

#include <windows.h>

#define Lang_RU		0x0419
#define Lang_US		0x0409
#define Lang_UDF	0x0000

//
//	getFileVersion
//		Gets sub block information from common version block of an existing file, 
//		if lang is undefined returns first block found
//
BOOL GetFileVersionBlock(
		const char *name,
		char *blockValue,
		DWORD *cbSize,
		const char *szSubBlockValue = "FileVersion",		// "FileDescription" // "LegalCopyright"
		WORD  wLang = Lang_UDF
	);

BOOL GetFileVersionBlockT(
		const wchar_t *name,
		wchar_t *blockValue,
		DWORD *cbSize,
		const wchar_t *szSubBlockValue = L"FileVersion",	// L"FileDescription" // L"LegalCopyright"
		WORD  wLang = Lang_UDF
		);

bool getFileVersion ( const char    *name, char    *blockValue, DWORD *cbSize, const char    *szSubBlockValue = "FileVersion",  WORD  wLang = Lang_UDF );
bool getFileVersionT( const wchar_t *name, wchar_t *blockValue, DWORD *cbSize, const wchar_t *szSubBlockValue = L"FileVersion", WORD  wLang = Lang_UDF );

bool getModuleVersion( HINSTANCE hInst, wchar_t *blockValue, DWORD *cbSize, const wchar_t *szSubBlockValue = L"FileVersion" );

class cWCS;
const wchar_t *getModuleVersion( cWCS &wcs, HINSTANCE hInst = NULL, const wchar_t *szSubBlockValue = L"FileVersion" );
const wchar_t *getFileVersion( cWCS &wcs, const wchar_t *path, const wchar_t *szSubBlockValue = L"FileVersion" );

//
//	CompareVersions
//		Compare version strings returned by GetFileVersionBlock with szSubBlockValue = "FileVersion"
//		returns negative if ver0 < ver1  
//		returns positive if ver0 > ver1 
//		returns zero if ver0 == ver1
//
int CompareVersions( const char *ver0, const char *ver1, int *pFieldsQ = NULL );
int CompareVersionsT( const wchar_t *ver0, const wchar_t *ver1, int *pFieldsQ = NULL  );
int CompareFileVersionsT( const wchar_t *path0, const wchar_t *path1, int *pFieldsQ = NULL  );

int CheckFileVersion( const wchar_t *path, const wchar_t *szVersion, int *pFieldsQ = NULL  );

extern const wchar_t *GetLegalCopyright( HMODULE hInst );

