#include "UnicodeFuncs.h"
#include "../CertificateLib/SMemory/SBlocks.h"

//
//	Packed buffer read functions:
//	Read required value and sets position ( *pPos ) to the end of processed value.
//	Returns -1 if error encountered.
//
extern int readIntFromBuffer ( BYTE *buff, int size, int *pPos );
extern bool writeIntToPTB( cPlainTextBlock *ptb, int val );

//
//	Function: readStringFromBuffer
//	Allocates new string.
//	Returns pointer to allocated string, it should be deleted after using.
//
//	The string from/to ptb functions use UTF8 conversion for compatibility with old version.
//
extern wchar_t *readStringFromBuffer( BYTE *buff, int size, int *pPos );
extern char *readStringFromBufferA( BYTE *buff, int size, int *pPos );

//
//	Function: writeStringToPTB
//	1. Writes string length
//	2. Writes the string values without end zero symbol
//
extern bool writeStringToPTB( cPlainTextBlock *ptb, const char *str );
extern bool writeStringToPTB( cPlainTextBlock *ptb, const wchar_t *str );

//
//	Functions: for read/write bytes to/from buffer
//		First value is integer size.
//		Followed by buffer.
//
bool writeBytesToPTB( cPlainTextBlock *ptb, const BYTE *bf, int size );
bool readBytesFromBuffer( BYTE *buff, int size, int *pPos, BYTE *bfOut, int bfOutSize );
