#pragma once

#include <windows.h>

//
//	Returns handle to the process current thread impersonated token.
//
HANDLE GetProcessImpersonatedToken( const wchar_t *odsFunc = NULL, int odsLine = 0 );
#ifdef _ODS
#define GetProcessImpersonatedToken_ODS() GetProcessImpersonatedToken( (_CRT_WIDE( __FUNCTION__)), __LINE__ )
#else
#define GetProcessImpersonatedToken_ODS GetProcessImpersonatedToken
#endif

#ifndef TokenElevationType
#define TokenElevationType	18
#define TokenElevation		20

//typedef enum _TOKEN_INFORMATION_CLASS {
//    TokenUser = 1,
//    TokenGroups,
//    TokenPrivileges,
//    TokenOwner,
//    TokenPrimaryGroup,
//    TokenDefaultDacl,
//    TokenSource,
//    TokenType,
//    TokenImpersonationLevel,
//    TokenStatistics,
//    TokenRestrictedSids,
//    TokenSessionId,
//    TokenGroupsAndPrivileges,
//    TokenSessionReference,
//    TokenSandBoxInert,
//    TokenAuditPolicy,
//    TokenOrigin,
//    TokenElevationType,
//    TokenLinkedToken,
//    TokenElevation,
//    TokenHasRestrictions,
//    TokenAccessInformation,
//    TokenVirtualizationAllowed,
//    TokenVirtualizationEnabled,
//    TokenIntegrityLevel,
//    TokenUIAccess,
//    TokenMandatoryPolicy,
//    TokenLogonSid,
//    MaxTokenInfoClass  // MaxTokenInfoClass should always be the last enum
//} TOKEN_INFORMATION_CLASS, *PTOKEN_INFORMATION_CLASS;

typedef enum x_TOKEN_ELEVATION_TYPE {
    xTokenElevationTypeDefault = 1,
    xTokenElevationTypeFull,
    xTokenElevationTypeLimited,
	xTokenElevationTypeError = -1
} xTOKEN_ELEVATION_TYPE, *xPTOKEN_ELEVATION_TYPE;

typedef struct x_TOKEN_ELEVATION {
    DWORD xTokenIsElevated;
} xTOKEN_ELEVATION, *xPTOKEN_ELEVATION;

#endif

extern bool isWindowsVista();
extern bool isWindowsVistaLimitedProcess( bool bForced = false );

//
//	GetPipeToken
//		1. Impersonates to pipe token.
//		2. Gets the token.
//		3. Reverts to self back.
//	Returns impersonanted pipe token or NULL.
//
HANDLE GetPipeToken( HANDLE hPipe );
