#include "UnicodeFuncs.h"
#include "clipboardFuncs.h"
#include "kbdEdit.h"
#include "cDlgKBParams.h"
#include "cKeyBlockParams.h"
#include "resource.h"
#include <stdlib.h>
#include <windowsx.h>
#include <richedit.h>

bool gOldModeCompatible = false;

//
// Funcs from pwdlg.cpp
//
int cKbdEdit::InsertCharToBuffer( char mbLetter, bool IsLetter )
{
	wchar_t Letter = ( wchar_t )mbLetter;
	return InsertCharToBufferW( Letter, IsLetter );
}

class cCheckBlock
{
public:
	static bool bCheck;

	cCheckBlock()
	{
		bCheck = true;
	}

	~cCheckBlock()
	{
		bCheck = false;
	}

};

bool cCheckBlock::bCheck = false;

int cKbdEdit::InsertCharToBufferW( wchar_t Letter, bool IsLetter, wchar_t letterShow, wchar_t wRnd )
{
	//ODSFuncS( _FormatT( L"%c, %s, %d, inside %s", Letter, getWCStr( IsLetter ), letterShow, getWCStr( cCheckBlock::bCheck ) ) );

	if ( cCheckBlock::bCheck )
	{
		//assert( false );
		ODS_fls( L"Assertion:: skipped" );
		return eOk;
	}

	cCheckBlock cb;
		
	DWORD bufferSize = cPassword::MaxLenght; // maxLen( m_buffer );

	DWORD caretPos = 0;
	DWORD selPos = 0;
	LRESULT res = 0;

	res = SendMessage( m_hEdit, EM_GETSEL, (WPARAM)&caretPos, (LPARAM)&selPos );

	if ( caretPos >= bufferSize )
	{
		MessageBoxT( GetParent(m_hEdit), _FormatT( L"The password should be 8 - %d char long.", bufferSize ), L"Warning!", MB_ICONEXCLAMATION );
		ODS_fls( _FormatT( L"Assertion:: carret position %d, bufferSize %d, result %X", caretPos, bufferSize, res ) );
		return eLongPwd;
	}

	// caretPos is numbered from 1, so we have to decrement it
//	if ( ( Letter != VK_BACK ) && (( Letter != VK_DELETE ) || IsLetter ) )
//	   caretPos--;

	DWORD pwdLength = Edit_LineLength( m_hEdit, 0 ); 
	if ( pwdLength >= bufferSize )
	{
		MessageBoxT( GetParent(m_hEdit), _FormatT( L"The password should be 8 - %d char long.", bufferSize ), L"Warning!", MB_ICONEXCLAMATION );
		ODS_fls( _FormatT( L"Assertion:: password length %d, bufferSize %d", pwdLength, bufferSize ) );
		return eLongPwd;
	}

	cWCStr wcs( maxLen( m_buffer ) );

	GetWindowTextT( m_hEdit, wcs.m_szBody, wcs.m_len );

	if ( Letter == VK_BACK ) 
	{
		if ( selPos == 0 )
			return eOk;

		if ( caretPos == selPos )
			caretPos--;
		
		IsLetter = false;
	}
	else
	if ( ( Letter == VK_DELETE ) && !IsLetter )
	{
		if ( caretPos == pwdLength ) //- 1 )
			return eOk;

		if ( caretPos == selPos )
			selPos++;
		
		IsLetter = false;
	}

	if ( caretPos != selPos )
	{
		for ( DWORD i = 0; i < pwdLength - selPos; i++ )
		{
			m_buffer[ caretPos + i ] = m_buffer[ selPos + i ];
			m_rndBuffer[ caretPos + i ] = m_rndBuffer[ selPos + i ];
			wcs.m_szBody[ caretPos + i ] = wcs.m_szBody[ selPos + i ];
		}
		
		pwdLength -= selPos - caretPos;
	}

	if ( IsLetter )
	{
		for( DWORD i = pwdLength + 1; i > caretPos; i-- )
		{
			m_buffer[ i ] = m_buffer[ i - 1 ];
			m_rndBuffer[ i ] = m_rndBuffer[ i - 1 ];
			wcs.m_szBody[ i ] = wcs.m_szBody[ i - 1 ];
		}

		m_buffer[ caretPos ] = Letter;
		m_rndBuffer[ caretPos ] = wRnd;
		wcs.m_szBody[ caretPos ] = letterShow;
		caretPos++;
		pwdLength++;
	}

	m_buffer[ pwdLength ] = 0;
	m_rndBuffer[ pwdLength ] = 0;
	wcs.m_szBody[ pwdLength ] = 0;

	if ( letterShow != 0 )
		SetWindowTextT( m_hEdit, wcs.m_szBody );

	Edit_SetSel( m_hEdit, caretPos, caretPos );

	//ODSF( L" password length %d, '%s', '%s', %d", pwdLength, m_buffer, wcs.m_szBody, IsLetter );

	PostMessage( GetParent( m_hEdit ), WM_BufferIsUpdated, 0, 0 );

	return eOk;
}

char getRandomLetter()
{
	static int val = 0;
	if ( val == 0 )
	{
		srand( (UINT)time(0) );
		val = 1;
	}

    int ticks = rand() % 26;
    return ( 'a' + ticks );
}

//
//	addSymbols
//		return number of added sumbols.
//
int cKbdEdit::addSymbols( const wchar_t *wcs, bool bShowChartacters, bool bAppend, bool bUseSecureTyping )
{
	if ( !bAppend )
		ClearBuff();

	int i = 0;

	for( ; wcs[i] != L'\0'; i++ )
	{
		wchar_t wRnd = getRandomLetter();
		wchar_t wShow = ( bShowChartacters ? wcs[i] : wRnd );
		int res = InsertCharToBufferW( wcs[i], true, wShow, bUseSecureTyping ? wRnd : wShow );

		if ( res == eLongPwd )
			break;
	}

	return i;
}

const WPARAM IC_wParam = 0xAA;
const LPARAM IC_lParam = 0xBB;

bool cKbdEdit::setEncodeTable( cDlgKBParams *dlg, HWND hDlg )
{
	ODSFuncS( getWCStr( dlg->m_useSecureTyping ) );

	if ( dlg->kbd.SetEncodingTable( dlg->m_useSecureTyping, m_setQ ) )
		return true;

	ODS_fls( L"Assertion!" );

	dlg->kbd.ResetEncodingTable( dlg->m_useSecureTyping, m_setQ );
	dlg->kbd.FreeTables( dlg->m_useSecureTyping );

	// Just to skeep multiply message box at next set focus..
	if ( !dlg->kbd.wasError )
	{
		dlg->kbd.wasError = true;
		MessageBoxT( hDlg, L"Error in setting encoding table", L"kbdEdit - editSubclassProc", MB_ICONSTOP );
	}

	EndDialog( hDlg, ERROR_INTERNAL_PROBLEM );

	return true;
}

static int wmKeyDown( cDlgKBParams *dlg,  WPARAM wParam, LPARAM lParam, bool bUseSecureTyping )
{
	ODSFuncS( getWCStr( bUseSecureTyping ) );

	UINT virtualKey = (UINT)wParam;
	UINT scanCode = (UINT)((lParam >> 16) & 0xFF);

	dlg->kbd.Wm_KeyDown( virtualKey, bUseSecureTyping, scanCode );
	dlg->kbd.IncrementCharacterOrderCNTRL( (int)wParam, bUseSecureTyping );

	int res = 0;

	if	(((dlg->m_keyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) == 0) &&
			( bUseSecureTyping && 
				( (wParam == VK_DELETE) /*|| (wParam == VK_BACK)  */ )
			)
		)
	{
		res = 0; // Skip executing of m_origWndProc
	}

	res = 1;

	ODSFuncRes( res );
	return res;
}

//
//	08.02.2018
//		Windows 10 at user log on opens password dialogue above our mount dialogue but does not send us WM_KILLFOCUS.
//		As result if secure type is used so key board filter continues encode symbols and the system password dialgue dies not get valid password.
//		Strategy 1:
//			System starts to send messages to other windows after user is logged on.
//			So we delay filtering up to first symbol is procesed see WM_KEYUP.
//			As result first symbol is not decoded. The delay will be minimized.
//	09.02.2018
//		Another strategy 2. We check focus in separate thread, if focus is lost so the thread post WM_USER_CHECK_FOCUS.
//		If focus is lost and encoding tables are assigned, so kill focus in emulated.
//		It works good if WM_KILLFOCUS mesage was lost. The lost kill focus was reported by Ben Duncan.
//
//	12.02.2018
//		It looks like Windows 10 at logon uses separate desctop, so the idea with checking foes does not work ( at logon time )
//		So check kill focus strategy 2 ( see above ) does not help at logon. 
//		Strategy 3. We'll disable strategy 2 but just once at login, all other time stratey 2 works.
//		See cKbdEdit::Attach.
//
bool bDelayFiltering = true; // According strategy 3, it is used once at mount at logon

LRESULT cKbdEdit::realEditProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	LRESULT lpRes = -1;
	char	letter;
	bool	isLetter  = false;
	DWORD   retCharsNum;
	//char    retChar1, retChar2;

	switch ( uMsg )
	{
		case WM_NCPAINT:
		case WM_GETDLGCODE:
		case WM_PAINT:
		case WM_ERASEBKGND:
		case WM_IME_SETCONTEXT:
		case WM_IME_NOTIFY:
			lpRes = KBD_CallWindowProc((WNDPROC)m_origWndProc, m_hEdit, uMsg, wParam, lParam);
			return lpRes;
		default:
			break;
	}

	//ODSFuncS( _FormatT( L"0x%04X, 0x%04X, 0x%04X, 0x%04X", uMsg, wParam, lParam, this ) );

	switch (uMsg)
	{
		case WM_PASTE:
		{
			//ODSF( L"WM_PASTE '%s'", lParam );

			cWCStr bf;
			if ( !ReadFromClipboard( m_hEdit, &bf, true ) )
				break;

			return addSymbols( bf.m_szBody ) > 0 ? 0 : -1;
		}

		case WM_INPUTLANGCHANGE:
		{
			ODSF( L"WM_INPUTLANGCHANGE: %X, %s", m_hEdit, getWCStr( dlg->m_useSecureTyping ) );
			ODS_fls( _FormatT( L"GetKeyboardLayout %X", (DWORD)GetKeyboardLayout( 0 ) ) );

			lpRes = KBD_CallWindowProc((WNDPROC)m_origWndProc, m_hEdit, uMsg, wParam, lParam);

			ODSF( L"WM_INPUTLANGCHANGE: result = %X", lpRes );

			PostMessage( m_hEdit, WM_USER_INPUTLANGCHANGE, IC_wParam, IC_lParam );

			return lpRes;
			//break;
		}

		case WM_USER_INPUTLANGCHANGE:
		{
			ODSF( L"WM_USER_INPUTLANGCHANGE: %X, %s", m_hEdit, getWCStr( dlg->m_useSecureTyping ) );

			if ( ( IC_wParam != wParam ) || ( IC_lParam != lParam ) )
			{
				ODS_fls( L"Assertion!" );
				break;
			}

			ODS_fls( _FormatT( L"GetKeyboardLayout %X", (DWORD)GetKeyboardLayout( 0 ) ) );

			if ( dlg->m_useSecureTyping && !bDelayFiltering )
			{
				dlg->kbd.noSemaphore = true;
				dlg->kbd.ResetEncodingTable( true, m_setQ );
				dlg->kbd.FreeTables( true);

				dlg->kbd.GenerateEncodingTable( true );
				dlg->kbd.SetEncodingTable( true, m_setQ );
				dlg->kbd.noSemaphore = false;
			}

			break;
		}

		case WM_SETFOCUS:
			ODSF( L"WM_SETFOCUS: %X, %d", m_hEdit, (int)bDelayFiltering );

			if ( !bDelayFiltering )
				setEncodeTable( dlg, GetParent(m_hEdit) );

			break;

		case WM_USER_CHECK_FOCUS:
		{
			HWND hWnd = GetFocus();
			ODS_fls( _FormatT( L"Focus %X, hEdit %X, Set count %d", hWnd, m_hEdit, m_setQ ) );
			if ( hWnd != m_hEdit ) // hWnd == NULL if no focus
			{
				ODS_fls( L"The editbox is not in focus! Stop check focus!" );
				m_hEditPost = NULL; // Stop check thread
				if ( m_setQ > 0 )
				{
					ODS_fls( L"Forse kill focus!" );
					// No break! It forse kill focus with reseting tables below..
				}
				else
					break;
			}
			else
				break;
		}
		case WM_KILLFOCUS:
		{
			ODSF( L"WM_KILLFOCUS: %X", m_hEdit );
			ODS_fls( _FormatT( L"GetKeyboardLayout %X", (DWORD)GetKeyboardLayout( 0 ) ) );

			if ( bDelayFiltering )
			{
				// bDelayFiltering = false;
			}
			else
			{
				bool bUseSecureTyping = dlg->m_useSecureTyping && !bDelayFiltering;

				if (!dlg->kbd.ResetEncodingTable( bUseSecureTyping, m_setQ ))
				{	// sends NULL string to delete all tables, because problems occured
					dlg->kbd.FreeTables( bUseSecureTyping );
				}
			}

			break;
		}

		case WM_KEYDOWN:
		{
			ODSF( L"WM_KEYDOWN:" );
			ODS_fls( _FormatT( L"GetKeyboardLayout %X", (DWORD)GetKeyboardLayout( 0 ) ) );

			m_bMhkHasDetectedKey = KBD_IsAnyKeyPressed() != FALSE;

			bool bUseSecureTyping = dlg->m_useSecureTyping && !bDelayFiltering && m_bMhkHasDetectedKey;
			
			UpdateSecureTypingView( dlg->m_useSecureTyping, !bDelayFiltering && m_bMhkHasDetectedKey );

			if ( wmKeyDown( dlg, wParam, lParam, bUseSecureTyping ) == 0 )
			{
				InsertCharToBuffer( wParam, false );
				return 0; // Skip executing of m_origWndProc
			}

			break;
		}

		case WM_SYSKEYUP:
			ODSF( L"WM_SYSKEYUP:" );
			break;
		case WM_SYSKEYDOWN:
			ODSF( L"WM_SYSKEYDOWN:" );
			break;
		case WM_DEADCHAR:
			ODSF( L"WM_DEADCHAR:" );
			dlg->kbd.Wm_DeadChar();
			break;

		case 0x0109: // WM_UNICHAR:
		{
			//ODSF( L"WM_UNICHAR '%c', %04X", (wchar_t)wParam, wParam );
			break;
		}

		case WM_SETTEXT:
		{
			cWCStr cws;

			wchar_t *s = (wchar_t*)lParam;

#ifndef UNICODE
			cws.Set( (char*)s, -1, CP_ACP );
			s = cws.m_szBody;
#endif

			//ODSF( L"WM_SETTEXT '%s'", s );

			if ( wcslen( m_buffer ) == 0 )
			{
				ODSF( L"Assertion! Buffer is empty..." );
				//
				// DigitalPersona-Password-Manager sometimes does not send WM_CHAR message 
				// but always sends WM_SETTEXT
				//

				if ( wcslen( s ) < maxLen( m_buffer ) )
					wcsncpy( m_buffer, s, maxLen( m_buffer ) );
				else
					ODSF( L"Assertion! Password length too large..." );
			}

			//for( int i = 0; s[i] != L'\0'; i++ )
			//{
			//	InsertCharToBufferW( s[i], true, 0 );
			//}
			break;
		}

		case WM_CHAR:
		{
			letter = (char)wParam;

			//ODSF( L"WM_CHAR '%c'", (char)wParam );
			ODS_fls( _FormatT( L"GetKeyboardLayout %X", (DWORD)GetKeyboardLayout( 0 ) ) );

			wchar_t wcs[ 10 ] = L"";

			// V.1.03.3
			// Reads symbols from keyboard by means of ToUnicodeEx instead of early version by ToAsciiEx
			//	the wcs string buffer is always filled even if secure typing was not assigned.
			//	So the function always gets valid result. 
			//	The character buffer is always filled too. But edit box cannot properly show
			//	the unicode characters if default system locale is not compatible.
			//	The CheckAndGetPassword has to get password from pwd buffer only.
			//

			bool bUseSecureTyping = dlg->m_useSecureTyping && !bDelayFiltering && m_bMhkHasDetectedKey;

			if (dlg->kbd.Wm_Char( letter, bUseSecureTyping, &retCharsNum, NULL, NULL, wcs, &wParam, &lParam ) )
			{
				//assert( wcslen( wcs ) == retCharsNum );

				bool bShowChartacters =
					!bUseSecureTyping ||
					((dlg->m_keyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) != 0 ) ||
					((dlg->m_keyGenFlags & FLAG_ADVANCED_TEST) != 0 );

				//
				//	A service symbol is detected. Rather CTRL+V
				//
				if ( ( retCharsNum == 1 ) && ( wcs[0] == 0x16 ) )
				{
					wParam = wcs[0];
					lpRes = KBD_CallWindowProc((WNDPROC)m_origWndProc, m_hEdit, uMsg, wParam, lParam);
					return lpRes;
				}

				if ( addSymbols( wcs, bShowChartacters, true, bUseSecureTyping ) > 0 )
					lpRes = 0;

			}
			else
			{
				// WM_CHAR default processing

				//lpRes = KBD_CallWindowProc((WNDPROC)m_origWndProc, m_hEdit, uMsg, wParam, lParam);
				//InsertCharToBuffer( (char)wParam );

				//
				// Version 1.03.6 - 30.11.2009
				// Direction is changed. The original procedure has to be called after InsertCharToBufferW.
				// The InsertCharToBufferW function suppouses that the charater is not processed yet.
				//

				ODS( L"dlg->kbd.Wm_Char returns false" );

				bool useOrigProc = true;

				//
				//	23.06.2011
				//	Back space is properly served by InsertCharToBufferW with showLetter as true.
				//
				if ( wParam == VK_BACK )
					useOrigProc = false;

				if ( useOrigProc )
				{
					InsertCharToBufferW( wParam, true, false );
					lpRes = KBD_CallWindowProc( (WNDPROC)m_origWndProc, m_hEdit, uMsg, wParam, lParam );
				}
				else
				{
					InsertCharToBufferW( wParam, true, true );
					lpRes = 0;
				}
			}

			return lpRes;
		}

		case WM_KEYUP:
		{
			bool bUseSecureTyping = dlg->m_useSecureTyping && !bDelayFiltering && m_bMhkHasDetectedKey;

			ODSF( L"WM_KEYUP: %d, %d, %d", (int)bDelayFiltering, (int)dlg->m_useSecureTyping, (int)bUseSecureTyping );

			dlg->kbd.IncrementCharacterOrder( (int)wParam, bUseSecureTyping );

			if ( bDelayFiltering )
			{
				setEncodeTable( dlg, GetParent(m_hEdit) );
				bDelayFiltering = false;
			}
			break;
		}
		default:
			break;
	}

	lpRes = KBD_CallWindowProc((WNDPROC)m_origWndProc, m_hEdit, uMsg, wParam, lParam);

	return lpRes;
}

bool cKbdEdit::CheckAndGetPassword( cPassword *pwd, cKbdEdit *edt, bool silent )
{
	if ( edt->m_hEdit == 0 )
	{
		assert( false );
		return false;
	}

	pwd->ClearBuffers();

	int pwdLength = Edit_LineLength( edt->m_hEdit, 0 );
/*
	ODSF( L"password length %d, buffered text length %d, buffer[0] %04X, %08X", 
		pwdLength, 
		wcslen( edt->m_buffer ),
		edt->m_buffer[0],
		edt );
*/
	if ( pwdLength == 0 ) 
	{
		pwdLength = wcslen( edt->m_buffer );

		if ( pwdLength != 0 )
		{
			ODS_fls( L"Assertion! Buffer really is not empty..." );
		}
		else
		{
			if ( !silent )
				MessageBoxT( edt->dlg->m_hDlg, _LoadIDS( IDS_PASSWORD_EMPTY ), _LoadIDS( IDS_INVALID_PWD ), MB_OK | MB_ICONWARNING );

			SetFocus(  edt->m_hEdit );
			return false;
		}
    } 

	//
	//	KGGhost aways fills edt->m_buffer
	//	But edt->m_hEdit does not properly shows symbols typed on key board and system locales are different.
	//	See v 1.03.3 p.2 description. And comments at realEditProc - > WM_CHAR:
	//

	pwd->ReadFromBuffer( edt->m_buffer, CP_UTF8, gOldModeCompatible );

	if ( pwdLength < pwd->MinimumLenght ) 
	{
		if ( !silent )
			MessageBoxT( edt->dlg->m_hDlg,
				_LoadIDS( IDS_PWD_TOO_SHORT ),
				_LoadIDS( IDS_INVALID_PWD ),
				MB_OK | MB_ICONWARNING );

		SetFocus( edt->m_hEdit );
		return false;
    } 

	if ( pwdLength > pwd->MaxLenght ) 
	{
		size_t len = wcslen( pwd->wcBuffer );

		if ( !silent )
			MessageBoxT( edt->dlg->m_hDlg,
				_FormatT( _LoadIDS( IDS_pwdIsTruncated_DD ), pwdLength, len ), // pwd->MaxLenght ),
				_LoadIDS( IDS_INVALID_PWD ),
				MB_OK | MB_ICONWARNING );
    } 

	return true;
}


//
//	CheckAndGetPassword
//		1. Checks password length, 
//		2. Verifies if edtB is not NULL,
//
bool cKbdEdit::CheckAndGetPassword( cPassword *pwd, cKbdEdit *edtA, cKbdEdit *edtB, bool silent )
{
	if ( edtA->m_hEdit == 0 )
	{
		assert( false );
		return false;
	}

	if ( !CheckAndGetPassword( pwd, edtA, silent ) )
		return false;

	if ( edtB == NULL )
		return true;

	int pwdConfirmLength = Edit_LineLength( edtB->m_hEdit, 0 );

	if ( pwdConfirmLength == 0 )
	{
		SetFocus( edtB->m_hEdit );
		return 0; // let user to type the second copy of password
	}

	cPassword pwdConfirm;

	if ( !CheckAndGetPassword( &pwdConfirm, edtB, true ) ||
		 ( wcscmp( pwd->wcBuffer, pwdConfirm.wcBuffer ) != 0 ) )
	{
		if ( !silent )
			MessageBoxT( edtB->dlg->m_hDlg, _LoadIDS( IDS_PASSWORD_NOT_SAME ), _LoadIDS( IDS_PASSWORD_MISMATCH ), MB_ICONEXCLAMATION );

		SetFocus( edtB->m_hEdit );
		return 0;
	}

	return true;
}

//static bool isRichEditControl( HWND hEdit )
//{
//	cWCStr cls( 100 );
//
//	if ( GetClassNameW( hEdit, cls.m_szBody, cls.m_len ) )
//		if ( wcsncmp( cls.m_szBody, L"RichEdit", 8 ) == 0 )
//			return true;
//
//	return false;
//}
//
//static HWND changeToRichEditControl( HWND hEdit )
//{
//	if ( isRichEditControl( hEdit ) )
//		return hEdit;
//
//	RECT r;
//	cDlg::GetDlgItemRect( GetParent( hEdit ), hEdit, &r );
//
//	DWORD dwStyle = GetWindowStyle( hEdit );
//
//	//InitCommonControls();
//
//	HWND hRTE = CreateWindowEx( 0, RICHEDIT_CLASS, L"", dwStyle, r.left, r.top, r.right - r.left, r.bottom - r.top, GetParent( hEdit ), NULL, NULL, NULL );
//
//	if ( hRTE == NULL )
//	{
//		int err = GetLastError();
//		assert( false );
//
//		HINSTANCE hInst = LoadLibrary( L"riched20.dll"  );
//		hRTE = CreateWindowEx( 0, RICHEDIT_CLASS, L"", dwStyle, r.left, r.top, r.right - r.left, r.bottom - r.top, GetParent( hEdit ), NULL, NULL, NULL );
//
//		//FreeLibrary( hInst );
//		
//		if ( hRTE == NULL )
//			return hEdit;
//	}
//
//	SetWindowFont( hRTE, GetWindowFont( hEdit ), false );
//
//	ShowWindow( hEdit, SW_HIDE );
//	ShowWindow( hRTE, SW_SHOW );
//
//	return hRTE;
//}

//
//	Keyborad filter problem!
//	If due to any problem WM_KILLFOCUS was not delivered to kbdEdit so we get problem with app what really get
//	focus it get random symbols instead. And later when we get focus again at kbdEdit we've got error here.
//
static DWORD dwCheckFocusSleepTime = 500;
static 
DWORD WINAPI postCheckFocusMessage(
    LPVOID lpThreadParameter
    )
{

	HWND *pWnd = ( HWND* )lpThreadParameter;
	for( ;; )
	{
		Sleep( dwCheckFocusSleepTime );

		if ( *pWnd == NULL )
		{
			ODS_fls( L"Stop!" );	
			break;
		}

		ODS_fls( _FormatT( L"Post message to hWnd %X", *pWnd ) );
		PostMessage( *pWnd, WM_USER_CHECK_FOCUS, 0, 0 );
	}

	return 0;
}

static bool isUserLogon()
{
	const wchar_t *cmd = GetCommandLineT( true );

	ODSFuncS( cmd );

	bool bEqu = ( _wcsicmp( cmd, L"AutoOpen" ) == 0 );

	ODSFuncRes( bEqu );

	return bEqu;
}

void cKbdEdit::UpdateSecureTypingView( bool bUseSecureTyping, bool bMhkHasDetectedKey )
{
	if ( !bUseSecureTyping || ( m_hLine == NULL ) )
		return;

	ShowWindow( m_hLine, bMhkHasDetectedKey ? SW_SHOW : SW_HIDE );
}

bool cKbdEdit::Attach( HWND hEdit, HWND hSecureTypingLine )
{
	dlg = (cDlgKBParams *)cDlg::GetDlgClass( GetParent( hEdit ) );
	if ( dlg == NULL )
		return false;

	m_hLine = hSecureTypingLine;

	kbd = &dlg->kbd; // m_kbParams;

	//m_hREDll = LoadLibrary( L"riched20.dll"  );
	//m_hEdit = changeToRichEditControl( hEdit );
	m_hEdit = hEdit;

	if ((dlg->m_keyGenFlags & FLAG_ADVANCED_SHOW_PWD_CHARS) != 0)
		Edit_SetPasswordChar( m_hEdit, 0);

	//m_bIsRichEditControl = isRichEditControl( m_hEdit );

	SetWindowLongPtrT( m_hEdit, GWLP_USERDATA, (LONG_PTR)this );
	assert( this == (cKbdEdit *)GetWindowLongPtrT( m_hEdit, GWLP_USERDATA ) );

	//
	//	HookKeyboardProc from kbd.h uses this setting 
	//
	kbd->SetParams( GetParent( m_hEdit ), kbd );
	assert( kbd == kbd->GetParams( GetParent( m_hEdit ) ) );

	m_origWndProc = (LONG_PTR)KBD_SetWindowProc( m_hEdit, (LONG_PTR)editProc);

	//
	//	'Check focus strategy' see bDelayFiltering comments, the strategy 3 works now.
	//	At logon the keyboard filter intercetion is delaied up to first WM_KEYUP message.
	//	At other time it checks focus and resets encoding if focus is lost.
	//
	static bool bCheckFocus = !isUserLogon(); // true;

	if ( bCheckFocus )
	{
		m_hEditPost = m_hEdit;
		bDelayFiltering = false;
		m_hThread = CreateThread( 0, 0, postCheckFocusMessage, &m_hEditPost, 0, NULL );
	}
	
	bCheckFocus = true;

	return true;
}

void cKbdEdit::Detach()
{
	m_hEditPost = NULL; // It stops thread postCheckFocusMessage

	if ( m_hThread != NULL ) // postCheckFocusMessage
	{
		DWORD dwWait = WaitForSingleObject( m_hThread, dwCheckFocusSleepTime * 2 );
		if ( dwWait != WAIT_OBJECT_0 )
		{
			ODS_fls( L"Assertyion! Error in wating thread" );
		}

		CloseHandle( m_hThread );
	}

	if ( m_hEdit == NULL )
		return;

	if ( m_origWndProc == NULL )
	{
		assert( false );
	}
	else
	{
		KBD_SetWindowProc( m_hEdit, (LONG_PTR)m_origWndProc );
		m_origWndProc = NULL;
	}

	SetWindowTextT( m_hEdit, L"          " );

	kbd->SetParams( GetParent( m_hEdit ), NULL );
//	SetWindowLongPtr( m_hEdit, GWLP_USERDATA, (LONG_PTR)NULL );
}
