#ifndef __BC_BFISH
#define __BC_BFISH

#define SERVICE_NAME	"BC_BFish"
#define DISPLAY_NAME    "BLOWFISH"
#define ALGORITHM_ID     0x80

// Key length in bits
#define KEY_LENGTH          (256)
#define KEY_LENGTH_EXTENDED (4168*8)

#define DRIVER_MAJOR_VERSION	1
#define DRIVER_MINOR_VERSION	1


/******* Hardware dependences *******/

// Currently we choose Intel processor
#define ORDER_DCBA 

/* DCBA - little endian - Intel */
#ifdef ORDER_DCBA
union unionDWORD 
 { DWORD Dword;
   struct
	{ BYTE Byte3;
      BYTE Byte2;
      BYTE Byte1;
      BYTE Byte0;
    } Byte;
 };
#endif	/* ORDER_DCBA */

/* ABCD - big endian - Motorola */
#ifdef ORDER_ABCD
union unionDWORD 
 { DWORD Dword;
   struct
	{ BYTE Byte0;
      BYTE Byte1;
      BYTE Byte2;
      BYTE Byte3;
    } Byte;
 };
#endif	/* ORDER_ABCD */

/* BADC - VAX */
#ifdef ORDER_BADC
union unionDWORD 
 { DWORD Dword;
   struct
	{ BYTE Byte1;
      BYTE Byte0;
      BYTE Byte3;
      BYTE Byte2;
    } Byte;
 };
#endif	/* ORDER_BADC */


/******* Exported functions *********/

#define IN

BOOL
KeyExtend( int    KeyLength,
		   PUCHAR KeySource,          // 32       8-bit  uchars
           PDWORD KeyDestination );   // (4168/4) 32-bit dwords

VOID
Encrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

VOID
Decrypt( DWORD *IVector, 
         DWORD *KeyAdress,
         DWORD *SrcBuffer,
         DWORD *DstBuffer,
         DWORD Length );    // in bytes

/************/

typedef union _BKEY { DWORD Key[1042];
                      struct { DWORD pArray[18];
                               DWORD sArray[4][256];
                             } Array;
                    } BKEY, *PBKEY;

VOID
Blowfish_ECB_Encrypt( PDWORD Left,
                      PDWORD Right,
		              PBKEY  KeyAddress );

VOID
Blowfish_ECB_Decrypt( PDWORD Left,
                      PDWORD Right,
		              PBKEY  KeyAddress );

#endif
