//
// Copyright (c) 2008, Jetico, Inc., Finland. All rights reserved.
//
// Implementation of XTS encryption mode for Little Endian Platform (Intel)
//

#ifndef __XTS_MODE
#define __XTS_MODE

#if defined(__cplusplus)
extern "C"
{
#endif

#define SECTOR_SIZE          512
#define SECTOR_SIZE_POWER    9

#define ALGORITHM_BLOCK_SIZE       16
#define ALGORITHM_BLOCK_SIZE_POWER 4

#if defined(__WIN95__)
#ifndef RECOVERY16
#define RECOVERY16 1
#endif
#endif

typedef void ProcEncryptECBmode16ByteBlockAlgorithm( 
                   unsigned char *InBuffer, 
                   unsigned char *OutBuffer,
                   unsigned char *Context );

#ifndef RECOVERY16

#ifndef ULONGLONG
typedef unsigned __int64 ULONGLONG;
#endif

int XTS_EncryptDecrypt( ProcEncryptECBmode16ByteBlockAlgorithm *EncryptProc,
                        ProcEncryptECBmode16ByteBlockAlgorithm *EncryptOrDecryptProc,
                        ULONGLONG                              SectorNumber, // or IV - Initial Vector
                        unsigned char                          *InBuffer,
                        unsigned char                          *OutBuffer,
                        unsigned long                          BufferLength,
                        unsigned char                          *Context_1,
                        unsigned char                          *Context_2 );
#else

int XTS_EncryptDecrypt( ProcEncryptECBmode16ByteBlockAlgorithm *EncryptProc,
                        ProcEncryptECBmode16ByteBlockAlgorithm *EncryptOrDecryptProc,
                        unsigned long                          *SectorNumber, // 2 32-bit numbers or IV - Initial Vector
                        unsigned char                          *InBuffer,
                        unsigned char                          *OutBuffer,
                        unsigned long                          BufferLength,
                        unsigned char                          *Context_1,
                        unsigned char                          *Context_2 );

#endif

#if defined(__cplusplus)
}
#endif

#endif // XTS_MODE
