#include <stdio.h>
#include <string.h>
#include <conio.h>

#include "../bc_cast.h"

struct 
    {    UCHAR key[ CAST_MAXIMUM_KEYSIZE_BYTES ];
         UCHAR plain[8];
         UCHAR cipher[8];
		 DWORD dataLength;
	} testVectorsCast[] =
{
	{ { 0x01, 0x23, 0x45, 0x67, 0x12, 0x34, 0x56, 0x78,
		0x23, 0x45, 0x67, 0x89, 0x34, 0x56, 0x78, 0x9A },
	  { 0x01, 0x23, 0x45, 0x67, 0x89, 0xAB, 0xCD, 0xEF },
	  { 0x23, 0x8B, 0x4F, 0xE5, 0x84, 0x7E, 0x44, 0xB2 }, 8 
	},
	{ { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
	  { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },
	  { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 }, 0 
	}
};



int main()
{
  int      i;
  UCHAR    outputData[8];
  BOOL     result;
  CastData extendedKey;
  char     ch;

  result = TRUE; // Assume everything will be Ok

  printf("\n");

  for (i=0; testVectorsCast[i].dataLength != 0; i++)
  {

	if (!KeyExtend( testVectorsCast[i].key, (DWORD *)&extendedKey ))
	{
		printf("\n(CAST ERROR) Test Vector N %d: error to extend encryption key!\n",i);
		return 0;
    }		
	  
	// Test if CAST encryption works correctly...
	if (!CastECB( testVectorsCast[i].plain, outputData, (DWORD *)&extendedKey, TRUE ))
	{
		printf("\n(CAST ERROR) Test Vector N %d: internal error (encryption)!\n",i);
		return 0;
	}

    if( memcmp( outputData, testVectorsCast[i].cipher, testVectorsCast[i].dataLength ) != 0)
	{
		printf("\n(CAST ERROR) Test Vector N %d: the CAST implementation failed the test (encryption)!\n",i);
		return 0;
	}

	
	// Test if CAST decryption works correctly...

	if (!CastECB( testVectorsCast[i].cipher, outputData, (DWORD *)&extendedKey, FALSE ))
	{
		printf("\n(CAST ERROR) Test Vector N %d: internal error (decryption)!\n",i);
		return 0;
	}

    if( memcmp( outputData, testVectorsCast[i].plain, testVectorsCast[i].dataLength ) != 0)
	{
		printf("\n(CAST ERROR) Test Vector N %d: the CAST implementation failed the test (decryption)!\n",i);
		return 0;
	}

    printf("Test Vector N %2d: the CAST implementation passed the test successfully.\n",i);
  }

  printf("Press any key to continue...\n");
  ch = getch();

  return 0;
}
